
#begin ----
rm(list = ls())
source("C:/Users/tinhv/Dropbox/PhD/Paper3_GlobalAnalysis/P3_Analysis/_RCoding/_supportFuncs/_callData.R")
source(paste0(path,"/_supportFuncs/Func06_ThemePlots.R"))
source(paste0(path,"/_supportFuncs/Func05b_RandomForest.R"))



#Fig. 9 - KGE in burble chats in R ----------
library(data.table)
# f <- "L:/04_Private/#Paper3_GlobalAnalysis/20230527_KGE_RF_toDischarge_perc_setV1_plot.csv"
f <- "C:/Users/tinhv/Dropbox/PhD/Paper3_GlobalAnalysis/P3_Figures/Q3_CART/_by_climatezones_strong_20230617/KGE_RF_toDischarge_perc_setV1.csv"
df <- fread(f)
head(df)
df$KGE <- as.numeric(gsub(",", ".", df$KGE))
df$KGE <- round(df$KGE, 2)

df$Clusters <- as.character(lapply(as.character(df$Clusters), renameClus)) #Func5b

df$size <- abs(df$KGE)

rec <- data.frame(xmin=-Inf, xmax=Inf, ymin=0.4, ymax=1)
  
df$Clusters <- factor(df$Clusters, 
                      levels = c("S-D1-Equa", "S-D1-Arid", "S-D1-WmFh", "S-D1-WmSd","S-D1-WmWd","S-D1-SnFh",
                                 "S-D1-SnSd", "S-D1-SnWd", "S-D1-Polar", 
                                 "S-D2", "S-D3", 
                                 "P-D1", "P-D2", "P-D3", 
                                 "W-D1", "W-D2", "W-D3"))
  


library(ggplot2)
p <- 
ggplot(df, aes(x = Clusters, y = KGE)) + 
  geom_rect(data=rec,
            aes(xmin=xmin, xmax=xmax, ymin=ymin, ymax=ymax), 
            fill="black", alpha=0.2, inherit.aes = FALSE) +
  geom_point(aes(color = Clusters, size = size), alpha = 0.5) +
  geom_text(aes(label= KGE),color='black',size=4.5)+
  
    scale_y_continuous(limits = c(-1, 1), breaks = seq(-1, 1, 0.2) ) +
  # scale_color_manual(values = c("#00AFBB", "#E7B800", "#FC4E07")) +
  scale_size(range = c(1, 18)) +  # Adjust the range of points size
  ylab("")+
  theme_bw()+
  theme(legend.position= "none",
        legend.text = element_text(size = 15),
        legend.key.width = unit(1.5,'cm'),
        legend.title = element_text(size = 15,face = 'bold'),
        plot.title = element_text(size = 15,face = 'bold'),
        axis.title.x =element_blank(),
        axis.title.y =element_text(size = 15, face = "bold", angle = 90, vjust = 0.5),    # to show sub-title in y-axis
        axis.text.y = element_text(size = 13),
        axis.text.x = element_text(size = 13,angle = 45,hjust = 1, vjust = 1),
        panel.grid.major.x =  element_line(colour='grey'),
        panel.grid.minor = element_blank(),
        strip.background = element_blank(),strip.text = element_text(size = 15,face = "bold"));p 

png(filename = gsub(".csv", ".png", f),
    width = 800, height = 350, type = "windows")
p
dev.off()






#---------------------------------------------------------------------------------------------#
####                 *Fig 2* -  GSIM Coverage  (global map)  -----------
#---------------------------------------------------------------------------------------------#
cpt_joint <- read.table( paste0(out_dir, "/Res1_Changepoint/Final_CPT_setB_MEAN_joint.Rres"), header = T, sep = ",")
gsim <- dplyr::left_join(cpt_joint, 
                         gsimFull[, c("gsim.no", "longitude", "latitude")],
                         "gsim.no")
gsim <- gsim[gsim$note == "-",]
gsim$length_clas <- ifelse(gsim$length_full > 100,
                           "> 100",
                           ifelse(gsim$length_full > 60,
                                  "60-100",
                                  ifelse(gsim$length_full > 40,
                                         "40-60",
                                         ifelse(gsim$length_full > 20,
                                                "20-40", "< 20"))))

# plot to world map
p <- baseworld2() +  
  geom_point(data = gsim,
             aes(x = longitude, 
                 y = latitude,
                 # size = factor(length_clas),
                 colour = factor(length_clas, 
                                 levels = c("> 100", "60-100", "40-60", "20-40", "< 20"),
                                 labels = c("> 100", "60-100", "40-60", "20-40", "< 20"))
             ),
             size = 4) +
  themeCPT_global(pts_size = c(3, 3),
                  color_lst = c("red","goldenrod2", "yellowgreen", "cyan4",  "grey"),#"palegreen1",
                  title = "Length of records:\n (in years)"); p


#save image
png(filename=paste0(out_fig,'/Q0_Coverage/Fig2_Coverage.png'), 
    width = 3000, height = 1500, type = "windows")
print(p)
dev.off()




#---------------------------------------------------------------------------------------------#
####              *Fig S1* - Time span of data                ####
#---------------------------------------------------------------------------------------------#

#call the results
gsim_cov <- read.table(file = paste0(out_dir,"/Res0_Precook/GSIM_coverage.csv"),header = TRUE,sep = ",")
# gsim_cov[212,1:6]<- 1 #this is to avoid the non-stop value
cont_lst <- names(gsim_cov[, -7])

#plot 
png(filename = paste(out_fig,"/Q0_Coverage/FigS1_LengthbyContinent_Withframe.png",sep = "" ),
    width = 1000, height = 450, type = "windows")
par(mfrow=c(2,3))

for (c in cont_lst[1:6]) {
  df <- gsim_cov[colnames(gsim_cov) %in% c(c,'year')]
  colnames(df)[1] <- 'cont'
  
  df[df==0] <- NA
  
  ##set the ylim
  y <- df[is.na(df$cont)==FALSE,]
  ymax <- round(max(y$cont),0)
  ifelse(c %in% c('Europe','North.America'),
         ymax <- 10000,
         ymax<-5000)
  ysep <- round(0.2*ymax,0)
  
  z <- quantile(y$cont,probs = c(.1,.75))
  y <- y[y$cont>z[1],]
  
  if(grepl("\\.", c)) c <- gsub("\\.", " ", c)
  
  #plot
  plot(df$year,df$cont,type = "l",ylim=c(0,ymax), xlab="", ylab="", xaxt = "n",yaxt = "n",
       adj=0.05,line=-2, bty="n",cex.axis=2, cex.lab=2.5,cex=1.2,cex.main =1.5,lwd=2,col="black",
       main=paste0(c))
  lines(df$year,df$cont,col="darkgoldenrod4",type = "h",pch=3,lty=2,lwd=0.5,cex=1)  
  abline(v=1960, col="red", lty=5,lwd=0.5)  
  abline(v=2010, col="red", lty=5,lwd=0.5) 
  
  axis(side=2,at=seq(0,ymax,ysep),lwd=1,cex.axis = 1.5)
  axis(side=1,at=seq(1800,2020,20), lwd = 1, cex.axis = 1.5)
  #mtext("Number of stations", side=2, at=12000,line= 2.5,cex=2)     #line to edit space between text and axis

}

dev.off()


#---------------------------------------------------------------------------------------------#
####              *Fig S2* - Violin plot for dam occurrence                ####
#---------------------------------------------------------------------------------------------#
#+ this can only be done after calculation in GA1-calcDAM
#+ 
library(ggplot2)
dams <- read.table(
  paste0(out_dir,"/Res0_Precook/Dam_listA.csv"),header = TRUE,sep = ";") #Dams_by_basin
dams <- dams[!is.na(dams$GRAND_ID),]

#find number of dam per each continent TO NAME BESIDE PLOT - no more need ---------------------#
# z <- as.data.frame(sapply(cont_lst, function(c) {
#   dff <-dams[dams$continent == c, ]
#   n <- data.frame(continent = c,
#                   num_dams = nrow(dff)
#   )
#   }))
# zt <- as.data.frame(t(z))
# # -------------------------------------------------------------------------------#


dams <- dams[dams$YEAR >= 1900,]
dams <- dams[dams$YEAR <= 2015,]

rec <- data.frame(xmin=-Inf, xmax=Inf, ymin=1960, ymax=2010)
dams$YEAR <- as.numeric(dams$YEAR)

text <- data.frame(continent = unique(dams$continent),
                   year = rep(2020, 6),
                   text = c(1,2,3,4,5,6))



library(ggplot2)#; library(ggforce) #for geom_sina
p <- ggplot(data = dams, aes(x=continent, y=YEAR)) +
  geom_violin(aes(fill=continent)) +
  geom_boxplot(width=0.1) +
  geom_text(data = text, aes(x = continent, y = year, label = text), size = 5) +
  # geom_sina(color = "cadetblue2", size = 0.05) +
  geom_rect(data=rec,
            aes(xmin=xmin, xmax=xmax, ymin=ymin, ymax=ymax), 
            fill="black", alpha=0.2, inherit.aes = FALSE) +
  scale_fill_brewer(palette = "RdBu") +
  ylab("") +
  xlab("") + theme_bw() +
  theme(legend.position ="none",
        plot.title = element_text(size = 20),    # gia tri cu 14
        axis.title.y =element_text(size = 13, face = "bold", angle = 90, vjust = 0.3,hjust = 0.45),    # to show sub-title in y-axis
        axis.title.x = element_text(size = 13,face = 'bold',hjust = 0.5),            # to hide sub-title in x-axis
        axis.text.y = element_text(size = 11),
        axis.text.x= element_text(size = 11),           
        axis.ticks.x=element_blank()) +        
  labs(fill = "");p


png(filename= paste0(out_fig,'/Q0_Coverage/FigS2_DamOccurrence.png'),
    width = 650, height = 300, type = "windows")
p
dev.off()


#---------------------------------------------------------------------------------------------#
####              *Data* - Combine infomation for paper####
#---------------------------------------------------------------------------------------------#
out_dir4 <- "D:/##PhD_20230701/P3_Results/Res4_DataInfo_forPaper"
# out_dir4 <- paste0(out_dir, "/Res4_DataInfo_forPaper")

cpt <- as.data.frame(fread(paste0(out_dir4, "/Data1_CPT.csv")))
damset <- as.data.frame(fread(paste0(out_dir4, "/Data2_Damset.csv")))
listdam <- as.data.frame(fread(paste0(out_dir4, "/Data3_ListDams_full.csv")))
gsim <- as.data.frame(fread(paste0(out_dir4, "/Data4_GSIM4_clean_full.csv")))
kgzone <- as.data.frame(fread(paste0(out_dir4, "/Data5_KGzone_final.Rres")))
gsRres <- as.data.frame(fread(paste0(out_dir4, "/Data6_VarChanges_diff.Rres")))


kgz <- as.data.frame(fread(paste0(out_dir4, "/KGzone_details.Rres")))
kgz$sub_cf <- substr(kgz$climates_f, 1,1); head(kgz)

lz <- unique(kgz$sub_cf); i = lz[1]

z <- list()

for (i in lz){
  # print(i)
  sb <- kgz[kgz$sub_cf == i, ]
  x <- as.data.frame(table(sb$gsim.no))
  print(paste0("zone ", i, " has ", nrow(x), " basins"))
  z[[i]] <- data.frame(zone = i,
                       nr_bs = nrow(x))
}
res <- rbindlist(z)
res$perc <- res$nr_bs*100/sum(res$nr_bs)


a <- kgz[is.na(kgz$climates_f), ]


x <- gsRres[, c('gsim.no',  'KG_zone', 'KG_mainzone', 'KG_actzone' )]
table(x$KG_zone)
# A    B   Cf   Cs   Cw   Df   Ds   Dw    E 
# 1365  779 6866 1300  533 5066  194   42  291 

table(x$KG_mainzone)
# A    B    C    D    E 
# 1351  769 8730 5313  273 

table(x$KG_actzone)
# Af   Am   As   AW  BSh  Bsk  BWh  Bwk  Cfa  Cfb  Cfc  Csa  Csb  Csc  Cwa  Cwb  Cwc  Dfa  Dfb  Dfc  Dfd  Dsa  Dsb  Dsc  Dsd  Dwa  Dwb  Dwc  Dwd   EF 
# 196  267   75  833  173  570   21   13 3302 3427  113  522  775   23  377  141    4  594 3160 1305    6    1   86   95    2    3   20   15    3    1 
# ET 
# 346 



#---- Data1: Basins using to detect changepoint
df <- cpt[cpt$note == "-", ] #25378 basins
x <- df[df$length_cpt >10, ]



#-- Summary changes in variable ------
faov <- paste0(out_fig,'/Q2a_VariablesChanges/_by_climatezone_strong/Q2_ANOVA.Rres'); faov
aov_res <- read.table(faov, header = TRUE,sep = ',')
for(i in 1:nrow(aov_res)){
  if (aov_res$diff[i] < 0) {
    aov_res$dir[i] <- -1
  } else {
    aov_res$dir[i] <- 1
  }
}
for(i in 1:nrow(aov_res)){
  if(is.na(aov_res$p_aov[i]) | aov_res$p_aov[i] > 0.05){
    aov_res$dir[i] <- aov_res$dir[i]
  } else {
    aov_res$dir[i] <- paste0(aov_res$dir[i], "*")
  }
}


df <- aov_res[ ,c("clusters", "VAR", "dir")]
dfs <- tidyr::spread(df, key = VAR, value = dir)
write.table(dfs, 
            paste0(out_dir, "/Res4_DataInfo_forPaper/Sum1_VarChanges.csv"), row.names = F, sep = ",")


#======== Finding basing having dams ==============================
#join the dam set with list of all dams
dfj <- dplyr::left_join(listdam, damset, "gsim.no"); head(dfj)
table(damset$dam_set)
# D1    D2    D3 
# 25786  1421  3728  ----> sum 30935 basins
y <- as.data.frame(table(dfj$GRAND_ID)) #-----> 4916 dams in consideration



#-------- a. Dams having no dams inside 1960-2010 ---------------------
d1 <- dfj[dfj$dam_set == "D1", ]; nrow(d1)

#--- a1. Completely no dam ------
a <- d1[is.na(d1$GRAND_ID), ] 
x <- as.data.frame(table(a$gsim.no)) #25719 basins no dam.
y <- as.data.frame(table(a$GRAND_ID)) #-----> 0 dams in consideration
print(paste0("set D1 - ", nrow(y), " dams built after 2010 (", nrow(x), " basins)"))


b <- d1[!is.na(d1$GRAND_ID), ] 
x <- as.data.frame(table(b$gsim.no))
y <- as.data.frame(table(b$GRAND_ID))
print(paste0("set D1 - ", nrow(y), " dams built after 2010 (", nrow(x), " basins)"))


#-------- b. Dams  ---------------------
d2 <- dfj[dfj$dam_set == "D2", ]
x <- as.data.frame(table(d2$gsim.no))
y <- as.data.frame(table(d2$GRAND_ID))
print(paste0("set D2 - ", nrow(y), " dams built prior to 1960 (", nrow(x), " basins)"))


d3 <- dfj[dfj$dam_set == "D3", ]
x <- as.data.frame(table(d3$gsim.no))
y <- as.data.frame(table(d3$GRAND_ID))
print(paste0("set D3 - ", nrow(y), " dams built between 1960-2010 (", nrow(x), " basins)"))





#------- Find different in set D1 --------------------#
gs1 <- df$gsim.no[df$dam_set == "D1"] #25786
gs2 <- d1$gsim.no #25739 basins

gs_diff <- setdiff(gs1, gs2) #48 basins

gs_info <- gsimFull[gsimFull$gsim.no %in% gs_diff, ]





#================== xxxxxx NO MORE NEED xxxxxxxxxxxx===================================


#-----------------------------------------------------#
#  *Plot* - Coverage of records in time (for Fig. 1)  - DONE     -----   
#-----------------------------------------------------#

#call the request file
gsim <- read.csv(paste0(out_dir,'/Res0_Precook/GSIM4_clean_full.csv'),header = TRUE,sep = ",")
gsim <- gsim[names(gsim) %in% c('gsim.no',"year.start","year.end","continent")]

cont_lst <- levels(as.factor(gsim$continent))

z <- list()
for (c in cont_lst) {
  
  #try co calculate the lenght of record
  df <- gsim[gsim$continent==c,]
  
  year_lst <- seq(1960,2010,1) ; year <- 1960
  
  y <- list()
  for (year in year_lst) {
    for  (i in 1:nrow(df)) {
      if (df$year.start[i] <= year & df$year.end[i] >= year) {
        df$a[i] <- 1
      } else { 
        df$a[i] <- 0 }
    }
    y[[year]] <- df$a
  } #close for year
  res <- as.data.frame(do.call(cbind,y))
  
  
  #count the number by year----------------------#
  b <- list()
  for (i in 1:ncol(res)) {
    b[[i]] <- sum(res[1:nrow(res),i])
  } #close number
  
  bres <- as.data.frame(do.call(rbind,b))
  colnames(bres) <- paste(c)
  bres$year <- year_lst
  
  z[[c]] <- bres
}#close for all continent

res <- as.data.frame(do.call(cbind,z))

#remove one colum
rm_col <- seq(2,10,2)
res <- res[,-rm_col] 
colnames(res) <- c(cont_lst,"year")

# 
# dt <- data.frame(a=1,b=1,c=1,d=1,e=1,f=1,year=2011)
# colnames(dt)[1:6] <- cont_lst
# 
# resall <- rbind(res,dt)

#write result
write.table(res,
            file = paste(out_dir,"Res0_Precook/GSIM_coverage_19602010.csv",sep = "/"),
            row.names = FALSE,sep = ",")




#---------------------------------------------------------------------------------------------#
####              *Plot*   Fig.4 - Category the signigicance of changes  (no need)                ####
#---------------------------------------------------------------------------------------------#
dfn <- data.frame(num.cpt = c(0,1,2,2,
                              3,3,3,
                              4,4,4,4,
                              5,5,5,5,5,
                              6,6,6,6,6,6),
                  freq = c(0,1,1,2,
                           1,2,3,
                           1,2,3,4,
                           1,2,3,4,5,
                           1,2,3,4,5,6),
                  clas = c("no",
                           'ww','ww','ww',
                           'pw','pw','pp',
                           'pw','pw','pp','pp',
                           'sw','sw','sp','sp','ss',
                           'sw','sw','sp','sp','ss','ss'))

dfn$clasnew <- substr(dfn$clas,1,1)
dfn$clasnew <- factor(dfn$clasnew, levels = c('n','w','p','s'), ordered = T)


#get them ordered
dfn$clas <- factor(dfn$clas, levels = c("no","ww",'pw','sw',"pp",'sp','ss'), ordered = T)

library(ggplot2)

p <- ggplot(dfn, aes(freq,num.cpt )) + geom_point()+
  #geom_tile(aes(fill = clasnew),  color = "white") +
  
  scale_fill_manual(values=c("grey70","olivedrab",'tomato',"red")) +
  
  xlab("Number of changes in same decade")+
  ylab("Number of changes detected") +
  
  
  guides(fill=guide_legend(override.aes=list(size = 2),        # edit size of symbol in legend
                           title = 'Classification:',
                           direction = "horizontal", title.position = "top",
                           ncol = 1)) +
  theme_bw() + 
  theme(legend.position= 'right',        
        legend.text=element_text(size=12),
        legend.title=element_text(size=12,face = 'bold'),
        legend.key.height=unit(1,"cm"),
        legend.key.size = unit(1,'cm'),
        axis.text=element_text(size = 12),
        axis.title=element_text(size = 12)) ; p


#save image
png(filename=paste("C:/Users/tinhvu/Dropbox/Paper3_Analysis_Globe/P3_Visualization/2. Changepoint/Fig1_cpt_category.png",sep = ""),
    width = 500, height = 250, type = "windows")
print(p)
dev.off()


#---------------------------------------------------------------------------------------------#
####              *Plot*  Example variable changes MEAN              ####
#---------------------------------------------------------------------------------------------#

Rres <- read.table(paste0(out_dir,'/Results_MainAnalysis/VariableChanges_MEAN.Rres'),header = TRUE,sep = ',')
#to rename the full name of continent to abbreviation
RresPlot <- Rres[colnames(Rres) %in% c('gsim.no','continent','cpt_ID',Rres_lst)]

library("RColorBrewer")
palette_set1 <- 'Paired' ; palette_set <- 'Set2'
#note: ggplot2::margin to avoid the error of'no applicable method for 'margin' applied to an object of class "c('double', 'numeric')"

df <- RresPlot[is.na(RresPlot$cpt_ID) ==FALSE,
               colnames(RresPlot) %in% c('continent',landcover)]

dfm <- reshape2::melt(df,by="continent") ; dfm <- na.omit(dfm)


#keep to same order
dfm$variable <- factor(dfm$variable,levels = landcover,ordered=T)


p <- ggplot() + 
  geom_boxplot(data = dfm, aes(x=continent, y=value, fill=factor(variable))) + 
  scale_fill_brewer(palette = palette_set) +
  scale_y_continuous(limits = c(-15,15), breaks = seq(-15,15,5))   + 
  ylab("Changes (%)") +
  ggtitle("Landcover changes")+
  scale_x_discrete(labels = function(x) str_wrap(x, width = 10)) +
  xlab("") +
  guides(fill=guide_legend(override.aes=list(size = 0.2),        # edit size of symbol in legend
                           title = "",
                           direction = "vertical", title.position = "left",
                           label.hjust = 0, label.vjust = 0.5, 
                           nrow = 1))+
  theme(legend.position = "bottom",
        #legend.key.height = unit(2,"line"),
        legend.title = element_text(size = 18,face = "bold"),
        legend.text = element_text(size = 18),
        plot.title = element_text(size = 22,face = "bold",margin = ggplot2::margin(t = 15, b = 5),hjust = 0.05),
        plot.margin = unit(c(1,0.5,0,0.5), "cm"),   #refer to t-r-b-l
        axis.title.y =element_text(size = 18,face = 'bold'),
        axis.title.x = element_blank(),
        axis.text.y= element_text(size = 20),             # to hide text in x-axis
        axis.text.x = element_text(size = 20),
        #axis.ticks.x=element_blank(),
        panel.border = element_rect(fill = NA),
        panel.grid.major = element_line(color = "grey"),
        panel.background = element_rect(fill = NA)); p

file_name= paste0(out_fig,"/VariablesChanges/Example.png")
png(file_name,width = 1000, height = 600, type = "windows")
print(p)
dev.off()



# #---------------------------------------------------------------------------------------------#
# ####      [2] - Fig 6. Plot the combined cpt      -----
# #---------------------------------------------------------------------------------------------#

library(data.table)


flow_lst <-  c("MEAN","MIN7","MAX7")
z <- list()
for (fl in flow_lst){
  df <- fread(paste0(out_dir,'/Results_ChangepointRes/Changepoint_classify_',fl,'.Rres'))
  z[[fl]] <- df$cpt_ID
}
cpt <- as.data.frame(do.call(cbind,z))
cpt$gsim.no <- df$gsim.no

dfm <- reshape2::melt(cpt,"gsim.no")
dfj <- dplyr::full_join(dfm,gsim[,c('gsim.no','continent')],'gsim.no')


library(ggplot2)
dfj <- dfj %>% mutate(continent = factor(continent),
                      continent = factor(continent, levels =rev(levels(continent))))


p <- ggplot(data=dfj, aes(x=continent,y=value, fill=variable )) +
  scale_colour_manual(values=palette ) +
  
  #scale_y_continuous(limits = c(1900,2025), breaks = seq(1900,2025,25))+
  coord_flip() +
  geom_boxplot() +
  #geom_text(data = dataMedian, aes(continent, MD, label = MD),
  #          position = position_dodge(width = 0.8),color = 'white', size = 4, hjust = -0.1) +
  
  ylab("Year of changes") +
  xlab("Continents") + theme_bw()+
  # facet_grid(.~continent, scales="free")+ #switch = "y") +
  theme(legend.position ="right",
        plot.title = element_text(size = 20),    # gia tri cu 14
        axis.title.y =element_text(size = 13, face = "bold", angle = 90, vjust = 0.3,hjust = 0.45),    # to show sub-title in y-axis
        axis.title.x = element_text(size = 13,face = 'bold',hjust = 0.5),            # to hide sub-title in x-axis
        axis.text.y = element_text(size = 13),
        axis.text.x= element_text(size = 13),             # to hide text in x-axis
        axis.ticks.x=element_blank()) +           # to hide vach ke in x-axis
  labs(fill = "Continents");p

# png(filename= paste0(out_fig,'/ChangePoints/Changedetection_Select.png'),
#     width = 500, height = 350, type = "windows")
# p
# dev.off()








