
#Author: Tinh Vu (tvu@hydrology.uni-kiel.de)


if(TRUE){
  source("C:/Users/tinhv/Dropbox/PhD/Paper3_GlobalAnalysis/P3_Analysis/_RCoding/_supportFuncs/_callData.R")
  # source(paste0(path,"/_supportFuncs/_callVarList.R"))
  
  dataSet <- "B"
  damSet <- "B"
  flow <- "MEAN"
  out_tiff <- paste0(out_dir,'/Res2_outTiffsRres')
  out_varChanges <- paste0(out_dir,'/Res2_VarChanges'); out_varChanges
  res_dir <- paste0(out_dir,'/Res3_Main_Analysis'); res_dir
  
  scriptName <- "GA02_Clean_for_Analysis.R"
}



#======================  STEP 1 - Changes diff, absdiff, perc to _calChanges folder ==================================== 

# results from this step will be used for final analysis
source(paste0(path,"/_supportFuncs/Func05_CalcVarChanges.R"))

#-------- PREPARING OUTPUT FOLDER -------------------#
if(!file.exists(out_varChanges)) dir.create(out_varChanges)
readme <- paste0( "\n",
                  "\n","Input are: \n", 
                  "Changpoint set: ", dataSet,"\n",
                  "Dam set: ", damSet,"\n",
                  "Flow type: ", flow,"\n", "\n",
                  "------Changes in diff, abs, perc are calculated in each datafile ------\n", 
                  "Input from: \n", 
                  out_tiff,"\n","\n",

                  "R Script used: \n", 
                  paste0(path, "/",scriptName),"\n")
writeLines(readme,
           paste0(out_varChanges,"/_READme.txt"))
#------------------------------------------------#

all_files <- list.files(out_tiff, pattern = ".Rres", recursive = F, full.names = TRUE); all_files

lst <- c("Precipitation", "Temperature", "RandomVar",
         "Urbanland", "WaterUse", "WaterVolume",
         "RatioDamB")
all_files <- all_files[grep(paste(lst, collapse = "|"), all_files)]; all_files


for(f in all_files){
  print(basename(f))
  
  #1. calculate changes
  res_diff <- calc_changes(f)
  
  # #3. write file to clean folder 
  write.table(res_diff,
              paste0(out_varChanges,"/", basename(f)),
              row.names = FALSE, sep = ",")
}

# change percentage (01.05.2023) -----
all_files <- list.files(out_varChanges, pattern = ".Rres", recursive = F, full.names = TRUE); all_files
lst <- c("Precipitation", "Temperature", "RandomVar",
         "Urbanland", "WaterUse", "WaterVolume",
         "DamB")
all_files <- all_files[grep(paste(lst, collapse = "|"), all_files)]; all_files; f=all_files[6]

for (f in all_files){
  # f <- all_files[f]; f
  print(basename(f))
  df <- as.data.frame(fread(f)); names(df); sapply(df, class)
  # "pre_avg"  "post_avg"
  # "cap_pre"   "cap_post"
  # "pre_ratio"  "post_ratio"
  
  for (i in 1:nrow(df)){
    print(i)
    pre <- df[i, grepl("pre_|p_pre", names(df))]
    pos <- df[i, grepl("post_|p_post", names(df))]

    if(is.na(pre)|is.na(pos)){
      df$perc[i] <- NA
    } else {
      if(pre == 0){
        if(pos == 0){
          df$perc[i] <- 0
        } else {
          df$perc[i] <- 100
        }
      }
    }
  }
  
  #over write table
  write.table(df, f, row.names = FALSE, sep = ",")
}

# #check plausibility ----xxxx------------
all_files <- list.files(out_varChanges, pattern = ".Rres", recursive = F, full.names = TRUE); all_files

i=13
# CHECK AREA SEE IN TEST PLAUSIBLE
if(TRUE){
  f <- all_files[i]; f
  print(basename(f))
  df <- fread(f)

  df <- df[!is.na(df$cpt_ID), ]

 dff <- df[df$perc > 1000, ]

 dff$area <- gsimFull$area[gsimFull$gsim.no %in% dff$gsim.no]

  # i <- 16264
  pre <- df$pre_avg[i]
  pos <- df$post_avg[i]

  dif <- pos-pre
  quantile(na.omit(df$diff))

  # n <- ncol(df)
  # bg <- n-4
  print(boxplot(df[, c("diff","absdiff","perc")]))
}

 
#======================  STEP 2 - Write last combined results to files  ==================================== 


#============  2.1 Call basic info =============================
f_grand <- paste0(out_tiff, "/Dam", damSet, ".Rres"); f_grand
f_damset <- paste0(out_dir, "/Res0_Precook/subsetDam.Rres")
f_cpt <- paste0(out_dir,"/Res1_Changepoint/Final_CPT_set", dataSet,"_",flow,".Rres"); f_cpt
f_trend <- paste0(out_dir,"/Res1_Trend/Trend_set", dataSet,"_",flow,".Rres"); f_trend
f_kg <- paste0(out_dir,"/Res0_Precook/KGzone_final.Rres"); f_kg

grand <- read.table(f_grand, header = TRUE, sep = ",")
damset <- read.table(f_damset, header = TRUE, sep = ",")
res_cpt <- read.table(f_cpt, header = TRUE, sep = ",")
res_trend <- read.table(f_trend, header = TRUE, sep = ",")
res_kg <- read.table(f_kg, header = TRUE, sep = ",")


library(dplyr)
library(purrr)
join_data <- as.data.frame(list(gsimFull[, c('gsim.no','longitude','latitude','altitude','continent','river','year.no',"area", "area_clas")],
                         grand[,c('gsim.no','dam_num','first_dam','last_dam')],
                         damset,
                         res_kg,
                         res_cpt[,c('gsim.no','cpt_ID','cpt_clas','num.cpt','len_yrs')],
                         res_trend[,c('gsim.no','p.value','trend')]) 
                    %>% reduce(left_join, by = "gsim.no")) #need package purrr




#=============== 2.2 Call all files (run after 2.1) =========================
source(paste0(path,"/_supportFuncs/Func05_CalcVarChanges.R"))

#-------- PREPARING OUTPUT FOLDER -------------------#
if(!file.exists(res_dir)) dir.create(res_dir)
readme <- paste0( "\n",
                  "\n","Input are: \n", 
                  "Changpoint set: ", dataSet,"\n",
                  "Dam set: ", damSet,"\n",
                  "Flow type: ", flow,"\n", "\n",
                  
                  "------ Combines all changes and values for whole data set in each basin ------\n", 
                  "Changes in variables (pre/post/abs/diff/perc) from: \n", 
                  out_varChanges,"\n", "\n",
                  "will be combined and prepared for the main analysis (ANOVA, CART, RF...)\n","\n",
                  "R Script: \n", 
                  paste0(path, "/",scriptName),"\n","\n",
                  "!!!Important!!!: \n",
                  "+) All NA-Changepoint will be removed from this steps\n",
                  "+) DamB/DamC... will be then all renamed as only Dam \n") 
writeLines(readme,
           paste0(res_dir,"/_READme.txt"))
#-----------------------------------------------------#

all_files <- list.files(out_varChanges, pattern = ".Rres", full.names = TRUE); f = all_files[1]; f
info_lst <- c("pre_avg", "post_avg", "diff", "absdiff", "perc")

for(i in info_lst){
  cat("-----------",i,'changes --------------\n')
  z <- list()
  for(f in all_files){
    VAR <- gsub(".Rres", "", basename(f)); print(VAR)
    
    df <- read.table(f, header = TRUE,sep=',')
    
    #add 15.04.2023 - remove NA-CPT out of series
    df <- df[!is.na(df$cpt_ID), ]
    
    
    #rename pre_post in dam
    inew <- i
    if(grepl("_avg", i) & grepl("Dam", VAR)){
      if(grepl("Ratio", VAR)){
        inew <- paste0(gsub("_avg", "", i), "_ratio")
      } else {
        inew <- paste0("cap_", gsub("_avg", "", i))
      }
    } 

    df <- df[, c("gsim.no", inew)]
    z[[f]] <- df[, 2]
  }
  res <- as.data.table(do.call(cbind, z))
  colnames(res) <- gsub(paste(c(out_varChanges, "/", ".Rres"), collapse = "|"),
                        "",
                        colnames(res))
  
  #------ shorten name of Dam ----------------#
  for(j in 1:ncol(res)){
    x <- colnames(res)[j]; print(x)
    if(grepl(paste0("am", damSet), x)) x <- gsub(damSet, "", x)
    colnames(res)[j] <- x
  }
  #------------------------------------------#
  res_all <- cbind(df$gsim.no, res); colnames(res_all)[1] <- 'gsim.no'

  #join with the jointdata above
  res_final <- dplyr::left_join(res_all, join_data, "gsim.no")
  
  inew <- i;   if(grepl("_avg", i)) inew <- gsub("_avg", "", i)
  nameout <- ifelse(grepl("pre|post", inew), 
                    "Values",
                    "VarChanges")
  write.table(res_final,
              file = paste0(res_dir,"/", nameout, "_", inew, '.Rres'),
              row.names = FALSE, sep = ",") 
}
# 
# f <- paste0(res_dir,"/VarChanges_perc.Rres")
# df <- as.data.frame(fread(f))
# df1 <-df[, c(climate, landcover, wateruse, "Discharge")]
# 
# boxplot(df1)





