
#Author: Tinh Vu (tvu@hydrology.uni-kiel.de)

#===========================================================================================#
###       >>> [Q2] - HOW ARE FACTORS CHANGES PRE AND POST CPT  <<< ---- 
###
#===========================================================================================#
# This version similar with v_20230531, but:
#+) with boxplot box in different group
#+) add shape for nonsignificant
# ToDO: colour doenst work in boxplot

if(TRUE) {
  rm(list = ls())
  source("C:/Users/tinhv/Dropbox/PhD/Paper3_GlobalAnalysis/P3_Analysis/_RCoding/_supportFuncs/_callData.R")
  source(paste0(path,"/_supportFuncs/Func05b_RandomForest.R"))
  source(paste0(path,"/_supportFuncs/Func06_ThemePlots.R"))
  source(paste0(path,"/_supportFuncs/_callVarList.R"))
  
  
  #list dataset used for this analysis ---  only for info ----#
  dataSet <- "B"
  damSet <- "B"
  flow <- "MEAN"
  
  typChange <- "perc" # "pre", "post", "diff", "absdiff", 
  static <- c("Altitude", "Area")
  VAR_full <- c(climate, landcover, wateruse, dam, static, "Discharge") #RandomVar is not necessarz in this step
}



###=========================================================================#
###--- 2.0 - Initial set to run/plot  -----
###=========================================================================#
#set V0: original = full - static
#set V1: full = original + static
#set V2: full - (water use + dam)
#set V3: full - (water use + dam + static)


#------START ------------

#option to rerun RF or not
calMedianChanges <- F
runANOVA <- F
plotPairwise <- F
runBoxplot <- F
plotFig6 <- T

#0. select option to run random Forest
clus_option = "climatezone" #can ben continents
subCluster = "strong"  #can be strong/pending/weak/all\
optCPT = F  #default is NULL, only applicable for continent_all to do cluster by strength of cpt


if(TRUE){
  # PREPARING DATA ==================================================================================================#
  #create new folder (if needed) --> based on option to calculate Randomforest
  out_dir_Q2 <- paste0(out_fig, "/Q2a_VariablesChanges/_by_", clus_option,"_", subCluster); out_dir_Q2
  if(!file.exists(out_dir_Q2)) dir.create(out_dir_Q2)
  
  setV_lst <- c("setV1") #, "setV0",  "setV2", "setV3")
  setVAR <- "setV1"
  
  # select set & call data-------------------------------------------3
  VAR_calChanges <- selSet(setVAR = "setV0", dataFull = VAR_full); VAR_calChanges #Func5b
  VAR_pairwise <- selSet(setVAR = "setV1", dataFull = VAR_full); VAR_pairwise #Func5b
  
  #call data
  Rres <- callRres(option = typChange,    #Func5b
                   out_dir,
                   rename_list = c('area', 'altitude'))
  # cluster by cliamte or continent
  if(grepl('continent', clus_option)){
    Rres <- getCluster_byCont(data = Rres,
                              option = subCluster,
                              optCPT )
  } else { #by climate
    Rres <- getCluster(data = Rres, #Func5b
                       subCluster) #can be strong/pending/weak/all
  }
  
  clus_lst <- as.data.frame(table(Rres$clusters))
  clus_lst <- clus_lst$Var1
  #==================================================================================================#

  #write clusters for other plot
  # write.table(Rres[, c("gsim.no", "clusters")],
  #             "Clusters_climate_Strong.Rres", sep = ",", row.names = F)
}




###=========================================================================#
###--- 2.1 Median of Changes -----
###=========================================================================#
            
if(isTRUE(calMedianChanges)){#important !!!! - this steps will calculate al changes fo whole variable
  dt <- Rres[ ,c('clusters', landcover, climate, wateruse, dam,
                 "RatioDam","Discharge")] #add more values to plot

  z <- list()
  for (clus in clus_lst){
    db <- dt[dt$clusters == clus, -1]
    x <- as.data.frame(apply(db, 2, median, na.rm = TRUE))
    
    colnames(x) <- clus
    z[[clus]] <- x
  }
  res <- do.call(cbind,z)
  
  library(tidyr)
  rows <- unique(c("Discharge", climate, landcover, wateruse, dam, "RatioDam"))
  res <- res[rows,]
  res$VAR <- rownames(res)
  
  file_out <- paste0(out_dir_Q2,'/Q2_MedianChanges.Rres')
  write.table(res, file_out, row.names = FALSE,sep = ',')
}




###=========================================================================#
###--- 2.2 ANOVA test (based on abs values) -----
###=========================================================================#
if(isTRUE(runANOVA)){
  
  # water volume is *1000 here, because it is too small
  VAR_lst <- c("Discharge", climate, landcover, wateruse, dam, "RatioDam"); VAR = VAR_lst[12]
  factor_lst <- clus_lst
  
  #----------- call pre/post values of variables, control wih cpt -----------#
  pre <-  read.table(paste0(out_dir,'/Res3_Main_Analysis/Values_pre.Rres'),header = T, sep = ',')
  post <-  read.table(paste0(out_dir,'/Res3_Main_Analysis/Values_post.Rres'),header = T, sep = ',')
  
  pre <- dplyr::left_join(pre, Rres[ , c("gsim.no", "clusters")])
  post <- dplyr::left_join(post, Rres[ , c("gsim.no", "clusters")])
  
  
  if(clus_option == "continent" & subCluster != "all"){
    pre <- pre[pre$cpt_clas == subCluster, ]
    post <- post[post$cpt_clas == subCluster, ]
  } 
  
  
  z <- list()
  for (VAR in VAR_lst){
    print(VAR)
    ifelse(VAR %in% climate, vargrp <- 'Climatic', vargrp <- 'Anthropogenic')
    
    df <- cbind(pre[,c("clusters", VAR)],
                post[,VAR]) ; head(df)
    colnames(df)<- c("factor","pre","post")
    
    
    ###---------------- added on 07.11 - find changes by static factors ----------------1
    
    k <- list(); b = factor_lst[2]
    
    for (b in factor_lst) {
      print(b)
      
      dff <- df[df$factor == b,]
      
      ##------------------ added on 09.12.19 ----------------------------#
      # this is when the clusters has no value of desert and/or PdRI
      # dff <- dff[!is.na(dff$pre), ]
      x <- na.omit(dff$pre)
      
      if(length(x)==0) {#whole sereies has no data
        res <- data.frame(clusters = b,p_aov = NA, pre_avg = NA, post_avg = NA, changes = NA,VAR) 
      } else {
        dfm <- reshape2:: melt(dff,'factor')
        res.aov <- aov(value ~ variable, dfm)    #<<<=== Ref180605: ANOVA test need one EXPLANATORY var (X) and one RESPONSE var (Y)
        
        #get the pvalue 
        p <- summary(res.aov)[[1]][["Pr(>F)"]][1] ; p
        
        ifelse(p <= 0.05,p, p <- NA)
        
        ### calculate ABSOLUTE changes 
        pre_avg <- median(na.omit(dff$pre))
        post_avg <- median(na.omit(dff$post))
        
        # if(VAR %in% c('WaterVolume')) {
        #   pre_avg <-  round(pre_avg*1000,2) #to make water volume 10-3 km3/knm2 #-- changed 15.04.2023- values has been already 10-3 km3/km2
        #   post_avg <- round(post_avg*1000,2)
        # }else {
        pre_avg <- round(pre_avg,2)
        post_avg <- round(post_avg,2)
        # }
        # 
        
        if(grepl('WaterUse|Irrigation', b)) {
          diff <- round(post_avg-pre_avg,3)
        } else {
          diff <- round(post_avg-pre_avg,2)
        }
        res <- data.frame(clusters = b, p_aov=p, pre_avg, post_avg, diff, VAR) 
      }
      
      k[[b]]  <- res
      
    }#close loop for factor
    res <- do.call(rbind,k)
    
    z[[VAR]] <- res
    z[[VAR]]$factor <- vargrp
  }
  res <- as.data.frame(do.call(rbind,z))
  
  file_out <- paste0(out_dir_Q2,'/Q2_ANOVA.Rres')
  write.table(res, file_out, row.names = FALSE,sep = ',')
}




###=========================================================================#
###--- **Fig_6**_Plot: Variable changes in boxplot -----
###=========================================================================#
# 27.05.2023
if(plotFig6){
  
# water volume is *1000 here, because it is too small
VAR_lst <- c("Discharge", climate, landcover, wateruse, "RatioDam"); VAR = VAR_lst[2]

#----------- call pre/post values of variables, control wih cpt -----------#
pre <-  read.table(paste0(out_dir,'/Res3_Main_Analysis/Values_pre.Rres'),header = T, sep = ',')
post <-  read.table(paste0(out_dir,'/Res3_Main_Analysis/Values_post.Rres'),header = T, sep = ',')

pre <- dplyr::left_join(pre, Rres[ , c("gsim.no", "clusters")])
post <- dplyr::left_join(post, Rres[ , c("gsim.no", "clusters")])


if(clus_option == "continent" & subCluster != "all"){
  pre <- pre[pre$cpt_clas == subCluster, ]
  post <- post[post$cpt_clas == subCluster, ]
} 


faov <- paste0(out_dir_Q2,'/Q2_ANOVA.Rres'); faov
aov_res <- read.table(faov, header = TRUE,sep = ',')

for(i in 1:nrow(aov_res)){
  if (aov_res$diff[i] < 0) {
    aov_res$dir[i] <- "Dec"
  } else {
    aov_res$dir[i] <- "Inc"
  }
}

for(i in 1:nrow(aov_res)){
  if(is.na(aov_res$p_aov[i]) | aov_res$p_aov[i] > 0.05){
    aov_res$sig[i] <- "nonSig"
  } else {
    aov_res$sig[i] <- "sig"
  }
}

aov_res$sigchange <- paste0(aov_res$sig, aov_res$dir)

#----------------------- divide variables to different groups ------------------#
#1. Discharge +
#2. Climate
#3. Landcover
#4. Water infrastructure (Water use, irrigation, ratio dam)

varSet <- c("Climate", "Landcover", "WaterInfras"); vSet = varSet[3]

for(vSet in varSet){
  if(grepl("Discharge", vSet)) VAR_lst1 <- "Discharge"
  if(grepl("Climate", vSet)) VAR_lst1 <- climate
  if(grepl("Landcover", vSet)) VAR_lst1 <- landcover
  if(grepl("WaterInfras", vSet)) VAR_lst1 <- c(wateruse, "RatioDam")
  
  #heere ------#
  VAR = "Irrigation"

  p <- list()
  for (VAR in VAR_lst1) {
  # if(TRUE){
    print(VAR)
    med_res <- aov_res[aov_res$VAR == VAR, ]

    rownames(med_res) <- med_res$clusters
    rows <- c("SD1A", "SD1B", "SD1Cf" ,"SD1Cs" ,"SD1Cw", "SD1Df" ,
              "SD1Ds", "SD1Dw","SD1E" , "SD2" ,  "SD3"  ,
              "PD1", "PD2", "PD3",
              "WD1",   "WD2" ,  "WD3" )
    med_res <- med_res[rows, ]
    
    #call the values of prec
    df <- cbind(pre[,c("clusters", VAR)],
                post[,VAR]) ; head(df)
    colnames(df) <- c("factor","pre","post")
    
    
    #try to log file for some variables ---------------------#
    # if(VAR %in% c("Discharge", "RatioDam", wateruse)){
    #   df$pre <- log(df$pre)
    #   df$post <- log(df$post)
    #   
    #   df <- df[!grepl("Inf", df$pre) & !grepl("Inf", df$post), ]
    #   
    #   #find median values after log
    #   for(i in 1:nrow(med_res)){
    #     cl <- med_res$clusters[i]
    #     
    #     subdf <- df$post[df$factor == cl]
    #     md = mean(na.omit((subdf)))
    #     
    #     med_res$post_avg[i] <- md
    #   }
    # }
    # 
    
    #--------------------------------------------------------#
    
    #remove all rows having no clusters
    df <- df[!is.na(df$factor), ]
    dfm <- reshape::melt(df, "factor")
    
    dfm$VAR = VAR
    # dfm$factor <- factor(dfm$factor, levels = c("SD1A", "SD1B", "SD1Cf" ,"SD1Cs" ,"SD1Cw", "SD1Df" ,
    #                                             "SD1Ds", "SD1Dw","SD1E" , "SD2" ,  "SD3"  ,
    #                                             "PD1", "PD2", "PD3",
    #                                             "WD1",   "WD2" ,  "WD3" ))
    #------ rename clusters (add 09.06.2023)---------------------------------#
    dfm$factor <- lapply(dfm$factor, renameClus)
    dfm$factor <- getLevelsClusters(dfm$factor)

    med_res$clusters <- lapply(med_res$clusters, renameClus)
    med_res$clusters <- getLevelsClusters(med_res$clusters)
    #--------------- Set the shape/color/label of dots based on directions of change---------------------#
    # med_res$sigchange <- factor(med_res$sigchange, levels = c("nonSigInc", "nonSigDec", "sigInc", "sigDec"))
    dir_lst <- levels(factor(med_res$sigchange)); dir_lst
    fill_lst <- as.character(lapply(as.character(dir_lst), function(x){
      xn <-switch (x,
                        nonSigDec = NA,
                        nonSigInc = NA,
                        sigDec = "red",
                        sigInc = "green"
      )
      }))
    fill_lst <- fill_lst[!grepl("NULL", fill_lst)]
    for(i in 1:length(fill_lst)){
      if(fill_lst[i] == "NA"){
        fill_lst[i] <- NA
      } else {
        fill_lst[i] <- fill_lst[i]
      }
    }; fill_lst
    
    shape_lst<- as.numeric(lapply(as.character(dir_lst), function(x){
      xn <- switch (x,
                    nonSigDec = 6,
                    nonSigInc = 2,
                    sigDec = 25,
                    sigInc = 24
      )
    }))
    dir_lst; shape_lst; fill_lst
   label_lst <- as.character(lapply(as.character(dir_lst), function(x){
      xn <- switch (x,
                    nonSigDec = "Non-Significant decrease",
                    nonSigInc = "Non-Significant increase",
                    sigDec = "Significant decrease",
                    sigInc = "Significant increase",
      )
    }))#; label_lst <- factor(label_lst, levels = c("Non-Significant decrease",
                                                   # "Non-Significant increase",
                                                   # "Significant decrease",
                                                   # "Significant increase"))


    #--------------- Plot to graph ---------------------#
    library(ggplot2) ; library(ggpubr); library(ggforce)
    col_lst <- c("dodgerblue", "darkmagenta")#"grey50") #cornflowerblue


    # p[[VAR]] <-
    p <- 
    ggpubr::ggboxplot(dfm, x = "factor", y = "value", 
                      color = "variable") + #, #size = 3,
                      # add = "jitter", add.params = list(color = "grey70")) + 
    geom_jitter(color = "grey70", size = 0.5) + #data = dfm, aes (x = factor, y = value, color = ("red"))) +
     geom_point(data = med_res,aes(x = clusters, y = post_avg, 
                                   shape = factor(sigchange), 
                                   fill = factor(sigchange)),
                size=5) +
      scale_color_manual(values = col_lst,labels = c("Pre-changed","Post-changed"),guide = FALSE)  +
      scale_shape_manual(values = shape_lst,
                         labels = label_lst, 
                         guide = FALSE) +
      scale_fill_manual(values = c(fill_lst, col_lst), guide=FALSE) +
      # scale_y_log10()+
      scale_y_continuous(trans = "log10") +
      # scale_y_continuous(limits = c(0, 1000)) + 
      ylab("") + 
      facet_wrap(~VAR, scales = 'free', nrow = 5, strip.position = "left") +  #Ref180518: Replace plot in loop by facet_wrap in r
      
      guides(shape = guide_legend(override.aes = list(size=6, 
                                                    shape = shape_lst, fill = fill_lst),
                                  keywidth = 0.3,keyheight = 0.5, default.unit="inch",  #keyheight: chieu cao cua text va symbol trong plot, keywidth: chieu rong cua text
                                  title = "Changes: ",
                                  direction = "vertical", title.position = "left",title.vjust = 1,
                                  label.hjust = 0, label.vjust = 0.5, 
                                  nrow = length(dir_lst)),
             color=guide_legend(override.aes=list(size=1),        # edit size of symbol in legend
                                keywidth=0.3,keyheight=0.5, default.unit="inch",  #change space between lines in legend
                                title = 'Period: ',
                                direction = "vertical", title.position = "left",
                                label.hjust = 0, label.vjust = 0.5, title.vjust = 1,
                                nrow = 2)) +
      theme_bw() +  theme(legend.position= "bottom",
                          legend.text = element_text(size = 20),
                          legend.title = element_text(size = 20,face = 'bold'),
                          plot.title = element_text(size = 15,face = 'bold',hjust = 0.5),
                          axis.title.x =element_blank(),
                          axis.title.y =element_text(size = 15, face = "bold", angle = 90, vjust = 0.5),    # to show sub-title in y-axis
                          axis.text.y = element_text(size = 20),
                          axis.text.x = element_text(size = 20,angle = 90,hjust = 1),
                          panel.grid.major.x =  element_blank(),
                          panel.grid.minor.x = element_blank(),
                          strip.background = element_rect(fill = "grey80"),strip.text = element_text(size = 30))
    
    png("test2.png", width = 700, height = 400, type = "windows")
    print(p)
    dev.off() 

    #get the legend to share for 3 plots 
    legend_share <- get_legend(p[[VAR]] + theme(legend.position ="bottom"))
    
  } #close loop for basin
  #Note: neu co loi khong tim thay get... ---> get back voi p[[VAR]]
  
  #select format
  if(grepl("Discharge", vSet)){
    w = 1400
    h = 550
    nc = 1
    nr = 1
  } else {
    if(grepl("Climate", vSet)){
      w = 1400
      h =  550
      nc = 2
      nr = 1
    } else {
      if(grepl("Landcover", vSet)){
        w = 2100
        h = 900
        nc = 3
        nr = 2
      } else { #water infras
        w = 1800
        h = 550
        nc = 3
        nr = 1
      }
    }
  }
  
  png(filename= paste0(out_dir_Q2, "/", Sys.Date(),"_VarChanges_AbsValues_", vSet,".png"),
      width = w, 
      height = h , type = "windows")
  
  #do.call(grid.arrange,c(p,ncol = 3))
  pp <- do.call(ggarrange,c(p,ncol = nc, nrow = nr, common.legend = TRUE, legend="bottom"))   # <<<<====== Ref180523: share legend for multiple plots : https://stackoverflow.com/questions/13649473/add-a-common-legend-for-combined-ggplots
  print(pp)
  dev.off() 
}#end of each varset


}



###=========================================================================#
###--- 2.3 Plot Pairwise correlation -----
###=========================================================================#

if(isTRUE(plotPairwise)){
  ## 2b1 - for percentage changes
  ## 2b2 - for each period pre- and after

  VAR_lst <- VAR_calChanges#c(climate,landcover,wateruse,dam,water,"Altitude", "Area")
  cols <- unique(VAR_lst)
  col1 <- colorRampPalette(c("#7F0000","red","#FF7F00","yellow","white", "cyan", "#007FFF", "blue","#00007F"))
  

  #================ a. Pairwise for continent (devided by dam) ====================================================
  #continent will be plot by dam set
  
  if(clus_option == "continent"){
    dam_lst <- c("D1", "D2", "D3"); d=dam_lst[1]
    
    for(d in dam_lst){
      print(d)
      
      fig_name <- paste0(out_dir_Q2,'/Pairwise_', typChange, "_", d,'_V0.png'); fig_name
      
      #in case need only certain class of cpt, it must be defined here
      if(clus_option == "continent" & subCluster != "all") Rres <- Rres[Rres$cpt_clas == subCluster, ]
      
      df <- Rres[grepl(d, Rres$clusters), ]
      #------------------------ ADDED ON 14.01.2020 -----------------------------------#
      #TRIED TO FIND THE CORRELATION OF PRECIPITATIO BY YEAR, NOT BY MONTH
      
      for (j in 1:ncol(df)) {
        k <- colnames(df)[j]
        
        ifelse(k %in% c(climate,'EvapoTrans',wateruse),
               df[,j] <- df[,j]*12,
               df[,j] <- df[,j])
      }
      ##---------------- Print --------------------------------------------#
      png(fig_name, width = 1500, height = 750, type = "windows") #3col,x2row = w1800, h950
      
      
      par(mfrow=c(2,3)) #row, col
      clus_lst1 <- as.character(clus_lst[grep(d, clus_lst)]);     c <- clus_lst1[2]; clus_lst1
      
      library(corrplot)
      for (c in clus_lst1) {
        print(c)
        dfc <- df[df$clusters==c,-which(names(df) %in% 'clusters')]
        
        ptitle <- gsub(d, "", c)
        
        if(ptitle == "NA"){
          ptitle <- "North America"
        }else {
          ptitle <- switch (ptitle,
                            AF = "Africa",
                            AS = "Asia", 
                            AU = "Australia",
                            EU = "Europe", 
                            SA = "South America")
        }

        ptitle <- paste0(ptitle, " (", nrow(dfc),")")
        
        dfc <- dfc[,cols]
        M <- cor(dfc, use="complete.obs")
        
        #reorder the order of table
        Mp <- data.frame(M)
        Mp <- Mp[cols,cols]
        #corrplot(M, type = "upper", order = "hclust",tl.col = "black", tl.srt = 90)
        corrplot(t(Mp),type='lower',#title = c,
                 tl.cex = 2,tl.col = 'grey50',cl.cex = 2,
                 method='square', col=col1(200),order = "original") #method: square, ellipse, shade
        mtext(ptitle, line=-3, cex=1.5, adj = 1)
      }
      dev.off()
    }
  } else {
    #================ b. *Fig_9* Pairwise for climate zones ====================================
    cpt_lst <- c("S", "P", "W"); d=cpt_lst[2]
    
    for(d in cpt_lst){
      print(d)
      
      fig_name <- paste0(out_dir_Q2,'/Pairwise_', typChange, "_", d,'_V0.png'); fig_name
      
      #in case need only certain class of cpt, it must be defined here
      # if(clus_option == "continent" & subCluster != "all") Rres <- Rres[Rres$cpt_clas == subCluster, ]
      
      df <- Rres[grepl(d, Rres$clusters), ]
      
      #------------- Rename clusters ----------------------------#
      df$clusters <- as.character(lapply(df$clusters, renameClus)) #func5b
      df$clusters <- getLevelsClusters(df$clusters) #func5b
      
      clus <- as.data.frame(table(df$clusters)); clus <- clus[clus$Freq >0,]
      clus_lst <- clus$Var1; clus_lst
      
      #------------------------ ADDED ON 14.01.2020 -----------------------------------#
      #TRIED TO FIND THE CORRELATION OF PRECIPITATIO BY YEAR, NOT BY MONTH
      
      for (j in 1:ncol(df)) {
        k <- colnames(df)[j]
        
        ifelse(k %in% c(climate,'EvapoTrans',wateruse),
               df[,j] <- df[,j]*12,
               df[,j] <- df[,j])
      }
      ##---------------- Print --------------------------------------------#
      if(d == "S"){
        w = 1800
        h = 1300
      } else {
        w = 1500
        h = 750
      }
      
      png(fig_name, width = w, height = h, type = "windows") #3col,x2row = w1800, h950
      
      if(d == "S"){
        par(mfrow=c(3,4)) #row, col
      } else {
        par(mfrow=c(1,3)) #row, col
      }
    
      clus_lst1 <- clus_lst[grep(d, clus_lst)]
      clus_lst1 <- getLevelsClusters(clus_lst1); c <- clus_lst1[2]; clus_lst1
      
      library(corrplot)
      for (c in clus_lst1) {
        print(c)
        dfc <- df[df$clusters==c,-which(names(df) %in% 'clusters')]

        ptitle <- c
        ptitle <- paste0(ptitle, " (", nrow(dfc),")")
        
        dfc <- dfc[,cols]
        M <- cor(dfc, use="complete.obs")
        
        #reorder the order of table
        Mp <- data.frame(M)
        Mp <- Mp[cols,cols]
        #corrplot(M, type = "upper", order = "hclust",tl.col = "black", tl.srt = 90)
        corrplot(t(Mp),type='lower',#title = c,
                 tl.cex = 2,tl.col = 'grey50',cl.cex = 2,
                 method='square', col=col1(200),order = "original") #method: square, ellipse, shade
        # mtext(ptitle, line=-3, cex=1.5, adj = 1)
        mtext(ptitle,
              side = 3, #1=below, 3=above, 2=left, 4=right
              line = -9, #distance with figure
              at = 8, #position of title -1=left side, 0=middle, 1= right side
              cex = 1.5, #fontsize of title
              font = 4 #1=normal, 2=bold, 3=italic, 4=bold+italic
        )
      }
      dev.off()
    }
    
  }
  
  
}

###=========================================================================#
###--- 2.4 Boxplot percentage changes -----
###=========================================================================#

if(isTRUE(runBoxplot)){
  faov <- paste0(out_dir_Q2,'/Q2_ANOVA.Rres'); faov
  # if(subCluster != "all") faov <- gsub(".Rres", paste0("_", subCluster,"CPT.Rres"), faov); faov
  
  aov_res <- read.table(faov, header = TRUE,sep = ',')
  
  #calc percentage of change in Anova
  aov_res$perc <- ifelse(aov_res$VAR %in% c(landcover),
                         aov_res$diff,
                         ifelse(aov_res$pre_avg ==0,
                                NA,
                                aov_res$diff*100/aov_res$pre_avg))
  #find direction of ANOVA change
  aov_res$dir <- ifelse(is.na(aov_res$p_aov),
                        0,
                        ifelse(is.na(aov_res$perc),
                               0,
                               ifelse(aov_res$perc > 0,1,-1)))
  
  aov_res$group <- ifelse(aov_res$VAR %in% climate,
                          "climate",
                          ifelse(aov_res$VAR %in% landcover,
                                 "landcover",
                                 ifelse(aov_res$VAR %in% wateruse,
                                        "wateruse",
                                        ifelse(aov_res$VAR %in% dam,
                                               "Dam",
                                               "Watervolume"))))
  
  #--------------- MATCH THE MEDIAN CHANGES FOR LANDUSE ----------------------------#
  #get the median changes from boxplot combine with anova
  fmed <- paste0(out_dir_Q2,'/Q2_MedianChanges.Rres')
  # if(subCluster != "all") fmed <- gsub(".Rres", paste0("_", subCluster,"CPT.Rres"), fmed); fmed
  
  dfmed <- read.table(fmed,header = TRUE,sep = ',')
  
  
  dfmed <- reshape2::melt(dfmed,'VAR')
  # dfmed$variable <- gsub2(c('North.America','South.America'),c('North America','South America'),dfmed$variable)
  colnames(dfmed)[2] <- 'clusters'
  
  for(i in 1:nrow(aov_res)){
    x <- as.character(aov_res$VAR[i])
    c <- as.character(aov_res$clusters[i])
    if(x %in% landcover) aov_res$perc[i] <- dfmed$value[dfmed$VAR == x & dfmed$clusters == c]
  }
  
  #define the VAR_list in this steps
  VAR_sel <- c(climate,landcover, wateruse, dam, "WaterVolume"); VAR_sel
  Rres <- Rres[colnames(Rres) %in% c('clusters', VAR_sel)]; head(Rres)
  
  
  #================ a. Boxplot by continent (devided by dam) ====================================
  if(clus_option == "continent"){
    dam_lst <- c("D1", "D2", "D3")
    
    for(d in dam_lst){
      print(d)
      fig_name= paste0(out_dir_Q2, "/Boxplot_VarChanges_", d, ".png")
      
      Rres1 <- Rres[grepl(d, Rres$clusters), ]
      clus_lst1 <- clus_lst[grepl(d, clus_lst)]  ; print(clus_lst1)
      
      require(ggplot2)
      p <- list()
      for(x in clus_lst1){
        print(x)
        # get values changes to plot boxplot --------------------#
        df <- Rres1[Rres1$clusters %in% x, ]; head(df)
        
        dfm <- reshape2::melt(df)
        
        #get ANOVA values to see the changes -------------------#
        aov <- aov_res[aov_res$clusters %in% x , ]
        aov <- aov[aov$VAR %in% VAR_sel, ]
        
        #prepare some figures to plot -----------------#
        dir_lst <- as.character(as.data.frame(table(aov$dir))$Var1)
        shape_lst <- shape_info(dir_lst) #Func6
        label_lst <- label_info(dir_lst) #Func6
        fill_lst <- fill_info(dir_lst)
        
        dfm$variable <- factor(dfm$variable,levels = VAR_sel, ordered = T)
        aov$VAR<- factor(aov$VAR,levels = VAR_sel, ordered = T)
        
        
        ptitle <- gsub(d, "", x)
        if(ptitle == "NA"){
          ptitle <- "North America"
        }else {
          ptitle <- switch (ptitle,
                            AF = "Africa",
                            AS = "Asia", 
                            AU = "Australia",
                            EU = "Europe", 
                            SA = "South America")
        }
        ptitle <- paste0(ptitle, " (", nrow(df),")")
        
        
        p[[x]] <-
          ggplot() +
          geom_boxplot(data = dfm, aes(x=variable, y=value), fill="grey90") +
          scale_y_continuous(limits = c(-50,100), breaks = seq(-50,100,50))   +
          
          geom_point(data=aov,aes(x=VAR,y=perc,shape=factor(dir),fill = factor(dir)),size=5,guide=FALSE,stat = "identity") +
          scale_shape_manual(values = shape_lst,labels = label_lst, guide = FALSE) +
          scale_fill_manual(values = fill_lst,guide=FALSE)+
          
          ylab("") +
          ggtitle(ptitle)+
          myTheme2() +
          guides(shape = guide_legend(override.aes=list(size=6,shape=shape_lst,fill = fill_lst),
                                      keywidth=0.3,keyheight=0.5, default.unit="inch",  #keyheight: chieu cao cua text va symbol trong plot, keywidth: chieu rong cua text
                                      title = "Changes: ",
                                      direction = "vertical", title.position = "left",title.vjust = 1,
                                      label.hjust = 0, label.vjust = 0.5, 
                                      nrow = 1)) +
          theme(axis.text.x = element_text(size = 20,angle = 45,hjust = 1))
      }
      
      library(ggpubr); library(stringr) #for str_wrap
      png(fig_name,width = 1600, height = 800, type = "windows")
      pp <- do.call(ggarrange,c(p,nrow = 2,ncol=3, common.legend = TRUE, legend="bottom"))   # <<<<====== Ref180523: share legend for multiple plots : https://stackoverflow.com/questions/13649473/add-a-common-legend-for-combined-ggplots
      print(pp)
      dev.off()
      
    }
  } else {
    #================ b. Boxplot by climate zones (devided by strenght of CPT) ====================================
    cpt_lst <- c("S", "P", "W"); d=cpt_lst[1]
    
    for(d in cpt_lst){
        print(d)
        fig_name= paste0(out_dir_Q2, "/Boxplot_VarChanges_", d, ".png"); fig_name
        
        Rres1 <- Rres[grepl(d, Rres$clusters), ]
        clus_lst1 <- clus_lst[grepl(d, clus_lst)]  ; clus_lst1
        
        require(ggplot2)
        p <- list()
        for(x in clus_lst1){
          print(x)
          # get values changes to plot boxplot --------------------#
          df <- Rres1[Rres1$clusters %in% x, ]; head(df)
          
          dfm <- reshape2::melt(df)
          
          #get ANOVA values to see the changes -------------------#
          aov <- aov_res[aov_res$clusters %in% x , ]
          aov <- aov[aov$VAR %in% VAR_sel, ]
          
          #prepare some figures to plot -----------------#
          dir_lst <- as.character(as.data.frame(table(aov$dir))$Var1)
          shape_lst <- shape_info(dir_lst) #Func6
          label_lst <- label_info(dir_lst) #Func6
          fill_lst <- fill_info(dir_lst)
          
          dfm$variable <- factor(dfm$variable,levels = VAR_sel, ordered = T)
          aov$VAR<- factor(aov$VAR,levels = VAR_sel, ordered = T)
          
          
          ptitle <- x
          ptitle <- paste0(ptitle, " (", nrow(df),")")
          
          
          p[[x]] <-
            ggplot() +
            geom_boxplot(data = dfm, aes(x=variable, y=value), fill="grey90") +
            scale_y_continuous(limits = c(-50,100), breaks = seq(-50,100,50))   +
            
            geom_point(data=aov,aes(x=VAR,y=perc,shape=factor(dir),fill = factor(dir)),size=5,guide=FALSE,stat = "identity") +
            scale_shape_manual(values = shape_lst,labels = label_lst, guide = FALSE) +
            scale_fill_manual(values = fill_lst,guide=FALSE)+
            
            ylab("") +
            ggtitle(ptitle)+
            myTheme2() +
            guides(shape = guide_legend(override.aes=list(size=6,shape=shape_lst,fill = fill_lst),
                                        keywidth=0.3,keyheight=0.5, default.unit="inch",  #keyheight: chieu cao cua text va symbol trong plot, keywidth: chieu rong cua text
                                        title = "Changes: ",
                                        direction = "vertical", title.position = "left",title.vjust = 1,
                                        label.hjust = 0, label.vjust = 0.5, 
                                        nrow = 1)) +
            theme(axis.text.x = element_text(size = 20,angle = 45,hjust = 1))
        }
        
        library(ggpubr); library(stringr) #for str_wrap
        
        if(d == "S"){
          w = 2000
          h = 1350
          nr = 3
          nc = 4
        } else {
          w = 1500
          h = 400
          nr = 1
          nc = 3
        }
        
        png(fig_name,width = w, height = h, type = "windows")
        pp <- do.call(ggarrange,c(p,nrow = nr, ncol=nc, common.legend = TRUE, legend="bottom"))   # <<<<====== Ref180523: share legend for multiple plots : https://stackoverflow.com/questions/13649473/add-a-common-legend-for-combined-ggplots
        print(pp)
        dev.off()
    }
    }
}
  




#---------------------------------------------------------------------------------------------#
####  TabS3 - Absolute MEDIAN CHANGES from ANOVA  -----
#---------------------------------------------------------------------------------------------#

factor_lst <- clus_lst
VAR_lst <- c("Discharge",'WaterVolume',climate, landcover, wateruse, dam, "RatioDam") #this table show water volume instead of discharge in any cases

library(dplyr)
if(TRUE) {
  #get the results of ANOVA --> to see which parameter is significant changed  -------------------#
  faov <- paste0(out_dir_Q2,'/Q2_Anova.Rres'); file_out
  if(subCluster != "all") faov <- gsub(".csv", paste0("_", subCluster,"CPT.csv"), faov); faov
  res_aov <- read.table(faov,header = TRUE,sep = ',')
  res_aov <- res_aov[res_aov$VAR %in% VAR_lst,]
  
  #get the median changes from boxplot ----------------------------------------------------------#
  fmed <- paste0(out_dir_Q2,'/Q2_MedianChanges.Rres')
  if(subCluster != "all") fmed <- gsub(".Rres", paste0("_", subCluster,"CPT.Rres"), fmed); fmed
  res_med <- read.table(fmed, header = TRUE,sep = ',')
  res_med <- reshape2::melt(res_med,'VAR')
  
  res_med$variable <- gsub2(c('North.America','South.America'),c('North America','South America'),res_med$variable)
  colnames(res_med)[2] <- 'clusters'
  
  
  ###joint the two results (ANOVA + median change) -------------------#
  df <- full_join(res_aov, res_med,by=c('VAR','clusters'))
  colnames(df)[ncol(df)] <- 'med_boxplot'
  
  
  ###calculate the absolute changes based on median boxplot -------------------#
  df$med_changes <- ifelse(df$VAR %in% c(landcover,"RatioDam"),
                           round(df$med_boxplot,2),
                           round(df$pre_avg*df$med_boxplot/100,2))

  ### note the value which have non-sig changes
  for(i in 1:nrow(df)) {
    if(is.na(df$p_aov[i]) ==TRUE) {
      df$med_changes[i] <- paste0(df$med_changes[i],'*')
    } 
  }
  
  
  library(tidyr)
  # Get vector of current column names (excluding "SampleFileName" and "Height" as they will not exist in final dataset) and all of the SampleFileName values.
  cols <- c('VAR', unique(factor_lst))
  rows <- unique(VAR_lst)
  
  #get the pre change values ---------------------------------------------------#
  df_pre <- df[colnames(df) %in% c('clusters','VAR','pre_avg')]
  df_pre <- spread(df_pre, clusters, pre_avg, fill = 0)
  
  rownames(df_pre) <- df_pre$VAR
  df_pre <- df_pre[rows,cols]
  df_pre$period <- "pre"
  
  
  #changes --- TAKE IT FROM MEDIAN IN BOXPLOT ----------------------------------#
  df_med <- df[colnames(df) %in% c('clusters','VAR','med_changes')]
  df_med <- spread(df_med, key=clusters, value=med_changes, fill = 0,convert = FALSE)
  
  rownames(df_med) <- df_med$VAR
  df_med <- df_med[rows,cols]
  df_med$period <- "post"
  
  
  res_all <- rbind(df_pre, df_med)
  
  file_out <- paste0(out_dir_Q2,'/TabS3_PreChanges_withANOVA.csv')
  if(subCluster != "all") file_out <- gsub(".csv", paste0("_", subCluster,"CPT.csv"), file_out); file_out
  
  write.table(res_all, file = file_out,row.names = FALSE,sep = ';')
  
}

  
  
  
   
  
  
  
  
  #---------------------------------------------------------------------------------------------#
  ####  FigSub - ChartCorrelation - by clusters  -----
  #---------------------------------------------------------------------------------------------#

  chg <- "post"
  f <- paste0(out_dir_Q2,'/VarChanges_',chg,'.Rres')
  if(grepl("pre|post", chg)) f <- paste0(out_dir_Q2,'/Values_',chg,'.Rres')
  
  df <- read.table(f,header = T, sep = ',')
  if(subCluster != "all") df <- df[df$cpt_clas == subCluster, ]
  
  
  df <- df[colnames(df) %in% c(climate,landcover,wateruse,dam,water,'clusters')]

  library(PerformanceAnalytics)
  for (c in clus_lst) {
    fig_name <- paste0(out_fig,'/Q2b_Pairwise/FigS_ChartCorr_',c,'_',chg,'.png'); fig_name
    if(subCluster != "all") fig_name <- gsub("Corr_", paste0("Corr_", subCluster,"CPT_"), fig_name); fig_name
    # print(c)
    dfc <- df[df$clusters==c,-which(names(df) %in% c('clusters'))]
    dt <-  na.omit(dfc)
    
    #get correlation
    if(FALSE) {
      for (j in climate){
        set <- c(j,water)
        tb <- dt[colnames(dt) %in% set]; colnames(tb) <- c('Var','Dis')
        print(paste0(j,'/',round(cor(tb$Var,tb$Dis),3)))
        plot(tb$Var,tb$Dis,main=j)
      }
    }

    #plot
    png(fig_name, width = 1300, height = 1000, type = "windows")
    chart.Correlation(dt,
                      method="pearson",
                      histogram=TRUE,
                      pch=16)
    dev.off()
  }
  
# }#end of auto run
    
    
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx----
    
    #---------------------------------------------------------------------------------------------#
    ####  Fig8_VarChanges_perc_byGroups - *not use*   -----
    #---------------------------------------------------------------------------------------------#
    
    
    aov_res <- read.table(paste0(out_dir_Q2,'/Q2_Anova.Rres'),header = TRUE,sep = ',')
    
    aov_res$perc <- ifelse(is.na(aov_res$p_aov) | aov_res$pre_avg ==0,
                           NA,
                           (aov_res$post_avg-aov_res$pre_avg)*100/aov_res$pre_avg)
    
    #direction of changes in each varialbes (increase, decrease)
    aov_res$dir <- ifelse(is.na(aov_res$p_aov),
                          0,
                          ifelse(is.na(aov_res$perc),
                                 0,
                                 ifelse(aov_res$perc > 0,1,-1)))
    
    aov_res$group <- ifelse(aov_res$VAR %in% climate,
                            "climate",
                            ifelse(aov_res$VAR %in% landcover,
                                   "landcover",
                                   ifelse(aov_res$VAR %in% wateruse,
                                          "wateruse",
                                          ifelse(aov_res$VAR %in% dam,
                                                 "Dam",
                                                 "Watervolume"))))
    #call the changes in variable
    Rres <- read.table(paste0(out_dir_Q2,'/VarChanges_', change ,'.Rres'),header = TRUE,sep = ',')
    Rres <- Rres[colnames(Rres) %in% c('clusters','gsim.no','cpt_ID',climate,landcover,wateruse,water)]
    
    
    library("RColorBrewer")
    palette_set1 <- 'Paired' ; palette_set <- 'Set2'
    
    #note: ggplot2::margin to avoid the error of'no applicable method for 'margin' applied to an object of class "c('double', 'numeric')"
    library(ggplot2)
    library(stringr)
    
    fig_name = paste0(out_dir_Q2, "/Fig8_VarChanges_perc_byGroups.png")
    
    
    if (TRUE) {
      #----------------------------- (1) Water volume -----------------------------------------------#
      df <- Rres[is.na(Rres$cpt_ID) ==FALSE,
                 colnames(Rres) %in% c('clusters',water)] 
      aov <- aov_res[aov_res$group %in% "Watervolume",]
      dir_lst <- as.character(as.data.frame(table(aov$dir))$Var1)
      
      shape_lst <- shape_info(dir_lst)
      label_lst <- label_info(dir_lst)
      fill_lst <- fill_info(dir_lst)
      
      
      colnames(df)[2] <- 'water'
      
      p <- ggplot() + 
        geom_boxplot(data = df, aes(x=clusters, y=water, fill=factor(clusters))) + 
        scale_y_continuous(limits = c(-100,200), breaks = seq(-100,200,50)) +
        
        geom_point(data=aov,aes(x=clusters,y=perc,shape=factor(dir),color = factor(dir)),size=5) +
        scale_shape_manual(values = shape_lst,labels = label_lst, guide = FALSE) +
        scale_color_manual(values = fill_lst,guide=FALSE)+
        
        scale_fill_brewer(palette = palette_set) + 
        ylab("Changes (%)") +
        ggtitle("Water Volume"); p
      
      p1 <- p+myTheme();p1
      
      
      # ----------------------------- Climate factor -----------------------------------------------#
      df <- Rres[is.na(Rres$cpt_ID) ==FALSE,
                 colnames(Rres) %in% c('clusters',climate)]
      dfm <- reshape2::melt(df,by="clusters"); dfm <- na.omit(dfm)
      
      aov <- aov_res[aov_res$group %in% "climate",]
      dir_lst <- as.character(as.data.frame(table(aov$dir))$Var1)
      
      shape_lst <- shape_info(dir_lst)
      label_lst <- label_info(dir_lst)
      fill_lst <- fill_info(dir_lst)
      
      #keep the order
      dfm$variable <- factor(dfm$variable,levels = climate,ordered = TRUE)
      library(ggsignif)
      library(ggplot2)
      
      p <- ggplot() + 
        geom_boxplot(data = dfm, aes(x=clusters, y=value, fill=variable)) + 
        scale_y_continuous(limits = c(-25,25), breaks = seq(-25,25,10)) +
        # geom_signif(stat="identity",
        #              data=data.frame(x=c(0.875, 1.875), xend=c(1.125, 2.125),
        #                              y=c(5.8, 8.5), annotation=c("**", "NS"))) +
        
        geom_point(data=aov,aes(x=clusters,y=perc,shape=factor(dir),color = factor(dir)),size=5) +
        scale_shape_manual(values = shape_lst,labels = label_lst, guide = FALSE) +
        scale_color_manual(values = fill_lst,guide=FALSE)+
        
        scale_fill_brewer(palette = palette_set) + 
        ylab("Changes (%)") +
        ggtitle("Climatic variables")
      p2 <- p+myTheme();p2
      
      
      
      #----------------------------- (2) Storage of dam-----------------------------------------------#
      df1 <- read.table(paste0(out_dir,'/Res2_outTiffsRres/clean_outTiff_set', dataSet, "_",flow,'/RatioDam_W.Rres'),header = TRUE,sep=',')
      df1$RatioDam_W <- df1$R_post-df1$R_pre
      
      df2 <- read.table(paste0(out_dir,'/Res2_outTiffsRres/clean_outTiff_set', dataSet, "_",flow,'/RatioDam_W.Rres'),header = TRUE,sep=',')
      df2$Dam_NoWithdraw <- df2$R_post-df2$R_pre
      
      library(dplyr)
      
      df <- full_join(df1[,c('gsim.no','RatioDam_W')],
                      df2[,c('gsim.no','Dam_NoWithdraw')],'gsim.no')
      
      df <- full_join(df[,c(1:3)],Rres[,c('gsim.no','clusters')])
      dfm <- reshape2::melt(df[,-1])
      
      dfm <- na.omit(dfm)#; dfm <- dfm[dfm$cap_change>0,]
      # dfm$clusters <- factor(dfm$clusters,levels = c('Africa','Asia','Australia','Europe','North America','South America'), ordered = T)
      
      aov <- aov_res[aov_res$group %in% "Dam",]
      dir_lst <- as.character(as.data.frame(table(aov$dir))$Var1)
      
      shape_lst <- shape_info(dir_lst)
      label_lst <- label_info(dir_lst)
      fill_lst <- fill_info(dir_lst)
      
      p <- ggplot() + 
        geom_boxplot(data = dfm, aes(x=clusters, y=value, fill=variable)) + 
        scale_fill_brewer(palette = palette_set) + 
        scale_y_log10()+
        # scale_y_continuous(limits = c(-25,25), breaks = seq(-25,25,10)) +
        
        geom_point(data=aov,aes(x=clusters,y=perc,shape=factor(dir),color = factor(dir)),size=5) +
        scale_shape_manual(values = shape_lst,labels = label_lst, guide = FALSE) +
        scale_color_manual(values = fill_lst,guide=FALSE)+
        
        ylab('Ratio (%)')+
        ggtitle("Ratio of dam (in log)")
      p3 <- p+myTheme();p3
      
      
      #----------------------------- Anthropogenic factors (3) -----------------------------------------------#
      df <- Rres[is.na(Rres$cpt_ID) ==FALSE,
                 colnames(Rres) %in% c('clusters',wateruse)]
      
      dfm <- reshape2::melt(df,by="clusters"); dfm <- na.omit(dfm)
      dfm$variable <- factor(dfm$variable,levels = wateruse,ordered=T)
      
      aov <- aov_res[aov_res$group %in% "wateruse",]
      dir_lst <- as.character(as.data.frame(table(aov$dir))$Var1)
      
      shape_lst <- shape_info(dir_lst)
      label_lst <- label_info(dir_lst)
      fill_lst <- fill_info(dir_lst)
      
      
      p <- ggplot() + 
        geom_boxplot(data = dfm, aes(x=clusters, y=value, fill=variable)) + 
        scale_fill_brewer(palette = palette_set) + 
        # scale_y_continuous(limits = c(-100,300), breaks = seq(-100,300,100))+
        
        geom_point(data=aov,aes(x=clusters,y=perc,shape=factor(dir),color = factor(dir)),size=5) +
        scale_shape_manual(values = shape_lst,labels = label_lst, guide = FALSE) +
        scale_color_manual(values = fill_lst,guide=FALSE)+
        
        ylab("Changes (%)")+
        ggtitle("Water consumption")
      p4 <- p+myTheme();p4
      
      
      #----------------------------- Landcover changes - natural landcover types  --------------------------------------------#
      df <- Rres[is.na(Rres$cpt_ID) ==FALSE,
                 colnames(Rres) %in% c('clusters',landcover)]
      dfm <- reshape2::melt(df,by="clusters") ; dfm <- na.omit(dfm)
      
      aov <- aov_res[aov_res$group %in% "landcover",]
      dir_lst <- as.character(as.data.frame(table(aov$dir))$Var1)
      
      
      shape_lst <- shape_info(dir_lst)
      label_lst <- label_info(dir_lst)
      fill_lst <- fill_info(dir_lst)
      
      
      #keep to same order
      dfm$variable <- factor(dfm$variable,levels = landcover,ordered=T)
      
      p <- ggplot() + 
        geom_boxplot(data = dfm, aes(x=clusters, y=value, fill=factor(variable))) + 
        # scale_fill_brewer(palette = palette_set) +
        scale_y_continuous(limits = c(-25,25), breaks = seq(-25,25,10))   +
        
        geom_jitter(data = aov,aes(x=clusters,y=perc,shape=factor(dir),color = factor(dir)),size=5,position=position_jitter(width=.1, height=0))+
        # geom_point(data=aov,aes(x=clusters,y=perc,shape=factor(dir),fill = factor(dir)),size=5,guide=FALSE,stat = "identity") +
        scale_shape_manual(values = shape_lst,labels = label_lst, guide = FALSE) +
        scale_color_manual(values = fill_lst,guide=FALSE)+
        
        ylab("Changes (%)") +
        ggtitle("Landcover changes")
      p5 <- p+myTheme();p5
      
      
      #----------------------------- saving plots -----------------------------------------------3
      cat("saving to ... ", fig_name, ' \n')
      library(grid)
      png(fig_name,width = 1200, height = 1000, type = "windows")
      
      grid.newpage()
      pushViewport(viewport(layout = grid.layout(3,12)))   #nrow, ncol
      vplayout <- function(x, y) viewport(layout.pos.row = x, layout.pos.col = y)
      print(p1, vp = vplayout(1,1:6))
      print(p2, vp = vplayout(1,7:12))
      print(p3, vp = vplayout(2,1:4))  # key is to define vplayout   #metric
      print(p4, vp = vplayout(2,5:12))         #climate
      print(p5, vp = vplayout(3,1:12))         #landcover
      #print(p6, vp = vplayout(4,1:10))         #landcover
      dev.off()
    }#close for auto

  