
#Author: Tinh Vu (tvu@hydrology.uni-kiel.de)

##=============================================================================================================##
####                      ANALYSIS AT GLOBAL SCALE  -   VISUALIZATION                                           ###
##=============================================================================================================##


if(TRUE) {
  source("C:/Users/tinhv/Dropbox/PhD/Paper3_GlobalAnalysis/P3_Analysis/_RCoding/_supportFuncs/_callData.R")
  source(paste0(path,"/_supportFuncs/Func06_ThemePlots.R"))
  
  #list dataset used for this analysis ---  only for info ----#
  dataSet <- "B"
  # damSet <- "B"
  # flow <- "MEAN"

  change_lst <- c("perc") # "pre", "post", "diff", "absdiff", 
  typChange <- "perc" 
  
  if(grepl("pre|post", typChange)){
    Rres <- fread(paste0(out_dir,'/Res3_Main_Analysis/Values_',typChange,'.Rres'))
  } else {
    Rres <- fread(paste0(out_dir,'/Res3_Main_Analysis/VarChanges_',typChange,'.Rres'))
  }; Rres <- as.data.frame(Rres)
  
  out_path <- paste0(out_fig,'/Fig1_ChangePoints')
}


#---------------------------------------------------------------------------------------------#
####                 *Input* -  Discharge info - no need to rerun   -----------
#---------------------------------------------------------------------------------------------#
# 
# library(zoo)
# gsim_lst <- gsimFull$gsim.no ; i <- gsim_lst[82]
#   z <- list()
#   for(i in gsim_lst){
#     cat("Running basin", match(i,gsim_lst), "\n")
#     
#     #read the manual discharge 
#     df <- read.table(paste0(Qpath,'/',i,".year"),header = T, sep = ",")
#     
#     #convert to numeric
#     for(j in 2:ncol(df)) if(!is.numeric(df[, j])) df[,j] <- as.numeric(df[, j])
#     
#     #select only the mean discharge to calculate
#     df <- df[, 1:2]
#     colnames(df)[2] <- 'discharge'
# 
# 
#     #------------------------------------------------------#
#     ### ERROR_1: some station has NA discharge
#     if(sum(is.na(df$discharge)) > 0.5*length(df$discharge)) {
#       res <- data.frame(gsim.no = i,
#                         begin_full = min(dat$year),
#                         end_full = max(dat$year),
#                         length_full = nrow(dat),
#                         begin_cpt = NA,
#                         end_cpt = NA,
#                         length_cpt = NA,
#                         note = "NA_more_than_50%")
#     } else {
#       #interpolate the NA values in files 
#       dfz <- read.zoo(df)   #convert to zoo series, prepare for interpolation
#       
#       #turn the zoo objects to data frame
#       dat <- fortify.zoo(na.approx(dfz,na.rm = TRUE))
#       names(dat) <- c("date", "discharge")
#       
#       dat$year <- format(as.Date(dat$date, format="%Y-%m-%d"),"%Y")
#       dat <- dat[, c('year','discharge')]
#       dat1 <- dat[dat$year >= 1960 & dat$year <= 2010, ]
#       
#       res <- data.frame(gsim.no = i,
#                         begin_full = min(dat$year),
#                         end_full = max(dat$year),
#                         length_full = nrow(dat),
#                         begin_cpt = min(dat1$year),
#                         end_cpt = max(dat1$year),
#                         length_cpt = nrow(dat1),
#                         note = "-")
#     }
#     z[[i]] <- res
# }
# res <- as.data.frame(rbindlist(z))
# res$note <- ifelse(!is.na(res$length_cpt) & res$length_cpt < 5, "less_than_5yrs_too_short", res$note)
# #convert to numeric
# for(j in 2:7) if(!is.numeric(res[, j])) res[,j] <- as.numeric(res[, j])
# 
# #combine with cpt
# res_cpt <- read.table(paste0(out_dir, "/Res1_Changepoint/Final_CPT_setB_MEAN.Rres"), header = T, sep = ",")
# 
# joint_cpt <- dplyr::full_join(res,
#                               res_cpt[, c("gsim.no", "cpt_ID", "cpt_clas")])
# 
# write.table(joint_cpt,
#             paste0(out_dir, "/Res1_Changepoint/Final_CPT_setB_MEAN_joint.Rres"), row.names = F, sep = ",")
# 


#---------------------------------------------------------------------------------------------#
####                 *Exp_Fig5a* -  Strength by length of records -   -----------
#---------------------------------------------------------------------------------------------#
cpt_joint <- read.table( paste0(out_dir, "/Res1_Changepoint/Final_CPT_setB_MEAN_joint.Rres"), header = T, sep = ",")
# write.table(cpt_joint, 
#             paste0(out_dir, "/Res4_DataInfo_forPaper/Data1_CPT.csv"),
#             row.names = F, sep = ",")



# 1. Find length of input gsim using to cal CPT
nrow(cpt_joint[cpt_joint$note == "-",]) #25378 stations

# 2. Relationship with length
cpt_res <- cpt_joint[!is.na(cpt_joint$cpt_ID), ] #---> 16470 stations having cpt

cpt_res$length_clas <- ifelse(cpt_res$length_cpt >= 40, "A",
                              ifelse(cpt_res$length_cpt >= 30, "B",
                                     ifelse(cpt_res$length_cpt >= 20, "C",
                                            "D")))
datSet <- c("A", "B", "C", "D"); s = datSet[1]
z <- list()
for(s in datSet){
  dat <- cpt_res[cpt_res$length_clas == s, ]
  x <- as.data.frame(table(dat$cpt_clas))
  x$pctg <- round(x$Freq*100/sum(x$Freq), 2)
  
  x$clas <- s
  
  z[[s]] <-  x[, -2]
}
res <- as.data.frame(rbindlist(z))
res$pctg <- gsub("\\.", ",", res$pctg)
res <- tidyr::spread(res, key = clas, value = pctg)

write.table(res, 
            paste0(out_dir, "/Res1_Changepoint/StrengthCPT_bylength.csv"), row.names = F, sep = ";")







#---------------------------------------------------------------------------------------------#
####                 *Exp_Fig5b* -  Strength by dam  -----------
#---------------------------------------------------------------------------------------------#

datSet <- levels(as.factor(Rres$dam_set)); s = datSet[1]
z <- list()
for(s in datSet){
  dat <- Rres[Rres$dam_set == s, ]
  x <- as.data.frame(table(dat$cpt_clas))
  x$pctg <- round(x$Freq*100/sum(x$Freq), 2)
  
  x$clas <- s
  
  z[[s]] <-  x[, -2]
}
res <- as.data.frame(rbindlist(z))
res$pctg <- gsub("\\.", ",", res$pctg)
res <- tidyr::spread(res, key = clas, value = pctg)

write.table(res, 
            paste0(out_dir, "/Res1_Changepoint/StrengthCPT_bydamset.csv"), row.names = F, sep = ";")




#---------------------------------------------------------------------------------------------#
####                 *Exp-FigS5* - No use -  Trend in (non) significant cpt   -----------
#---------------------------------------------------------------------------------------------#
cpt_joint <- read.table( paste0(out_dir, "/Res1_Changepoint/Final_CPT_setB_MEAN_joint.Rres"), header = T, sep = ",")

cpt_set <- cpt_joint[cpt_joint$note == "-",]
cpt_NA <- cpt_set#[!is.na(cpt_set$cpt_ID), ]
cpt_NA$length_clas <- ifelse(cpt_NA$length_cpt >= 40, "A",
                              ifelse(cpt_NA$length_cpt >= 30, "B",
                                     ifelse(cpt_NA$length_cpt >= 20, "C",
                                            "D")))
f_trend <- paste0(out_dir,"/Res1_Trend/Trend_setB_MEAN.Rres"); f_trend
res_trend <- read.table(f_trend, header = TRUE, sep = ",")


cpt_NA <- dplyr::left_join(cpt_NA,
                           res_trend[, c("gsim.no", "trend")])

datSet <- c("A", "B", "C", "D"); s = datSet[1]
z <- list()
for(s in datSet){
  dat <- cpt_NA[cpt_NA$length_clas == s, ]
  x <- as.data.frame(table(dat$trend))
  x$pctg <- round(x$Freq*100/sum(x$Freq), 2)
  
  x$clas <- s
  
  z[[s]] <-  x[, -2]
}
res <- as.data.frame(rbindlist(z))
res$pctg <- gsub("\\.", ",", res$pctg)

res <- tidyr::spread(res, key = clas, value = pctg)

write.table(res, 
            paste0(out_dir, "/Res1_Changepoint/Trend_bylength_all.csv"), row.names = F, sep = ";")





#---------------------------------------------------------------------------------------------#
####                 *Table 2* - Spatial coverage of change  -----------
#---------------------------------------------------------------------------------------------#
cpt_joint <- read.table( paste0(out_dir, "/Res1_Changepoint/Final_CPT_setB_MEAN.Rres"), header = T, sep = ",") 

cpt_set <- cpt_joint[cpt_joint$note == "-",]
cpt_res <- dplyr::left_join(cpt_set, gsimFull[, c("gsim.no", "continent")])


datSet <- levels(as.factor(cpt_res$continent)); s = datSet[1]
z <- list()
for(s in datSet){
  dat <- cpt_res[cpt_res$continent == s, ]
  dat$cpt_clas <- ifelse(is.na(dat$cpt_clas), "nonSig", dat$cpt_clas)
  x <- as.data.frame(table(dat$cpt_clas))
  # x$pctg <- round(x$Freq*100/sum(x$Freq), 2)
  
  x$clas <- s
  
  z[[s]] <-  x#[, -2]
}
res <- as.data.frame(rbindlist(z))

res <- tidyr::spread(res, key = clas, value = Freq)

write.table(res, 
            paste0(out_dir, "/Res1_Changepoint/SpatialCoverage_CPT_clas.csv"), row.names = F, sep = ",")






#---------------------------------------------------------------------1
###                 *Fig_4* - All CPT by continent - Boxplot  ----
#---------------------------------------------------------------------1
library(ggplot2)
p <- ggplot(data = Rres, 
            aes(x = continent,
                y = cpt_ID, 
                fill = factor(cpt_clas,levels = c("strong", "pending", "weak"),
                              labels = c("Strong", "Pending", "Weak")
                )
            )
) +
  scale_y_continuous(limits = c(1960,2010), breaks = seq(1960,2010,10))+ 
  # scale_fill_manual(values = c("goldenrod2", "yellowgreen", "cyan4")) +
  scale_fill_manual(values = c("chocolate3", "cyan4", "gray60")) +
  # geom_density(alpha = 0.2) +
  geom_boxplot() +
  ylab("") +
  xlab("") + theme_bw()+
  
  #facet_grid(.~MainClimateZ, scales="free")+ #switch = "y") +
  theme(legend.position ="right",
        plot.title = element_text(size = 20),    # gia tri cu 14
        axis.title.y =element_text(size = 13, face = "bold", angle = 90, vjust = 0.3,hjust = 0.45),    # to show sub-title in y-axis
        axis.title.x = element_text(size = 13,face = 'bold',hjust = 0.5),            # to hide sub-title in x-axis
        axis.text.y = element_text(size = 13),
        axis.text.x= element_text(size = 13),             # to hide text in x-axis
        axis.ticks.x=element_blank()) +           # to hide vach ke in x-axis
  labs(fill = "Strength:");p

#write to files
png(filename= paste0(out_fig,'/Q1_ChangePoints/Fig4_allCPT_by_continent.png'),
    width = 700, height = 350, type = "windows")
p
dev.off()






# ----------- NO MORE USE ---------------------------


#---------------------------------------------------------------------1
###                 *Exp_Plot4* - CPT by clusters - Boxplot  ----
#---------------------------------------------------------------------1

#add 02.06.2023
library(ggplot2)
clus <- read.table(paste0(path, "/Clusters_climate_Strong.Rres"), header = T, sep = ",")
clus <- dplyr::left_join(clus, Rres, "gsim.no")
clus$clusters <- factor(clus$clusters, levels = c("SD1A", "SD1B", "SD1Cf" ,"SD1Cs" ,"SD1Cw", "SD1Df" ,
                                                  "SD1Ds", "SD1Dw","SD1E" , "SD2" ,  "SD3"  ,
                                                  "PD1", "PD2", "PD3",
                                                 "WD1",   "WD2" ,  "WD3" ))
library(tidyverse)
dataMedian <- summarise(group_by(clus, clusters), MD = round(median(cpt_ID),0))

p <-
ggplot(data = clus, 
            aes(x = clusters,
                y = cpt_ID, 
                fill = factor(cpt_clas,levels = c("strong", "pending", "weak"),
                              labels = c("Strong", "Pending", "Weak")
                )
                )
            ) +
  # geom_text(data = dataMedian, aes(clusters, MD, label = MD),
            # position = position_dodge(width = 0.8), size = 3, vjust = -0.5) +
  
  scale_y_continuous(limits = c(1960,2010), breaks = seq(1960,2010,10))+ 
  scale_fill_manual(values=c("#E69F00", "#56B4E9", "#999999")) +
  # scale_fill_manual(values = c("goldenrod2", "yellowgreen", "cyan4")) +
  # geom_density(alpha = 0.2) +
  geom_boxplot() +
  ylab("") +
  xlab("") + theme_bw()+
  theme(legend.position ="right",
        plot.title = element_text(size = 20),    # gia tri cu 14
        axis.title.y =element_text(size = 13, face = "bold", angle = 90, vjust = 0.3,hjust = 0.45),    # to show sub-title in y-axis
        axis.title.x = element_text(size = 13,face = 'bold',hjust = 0.5),            # to hide sub-title in x-axis
        axis.text.y = element_text(size = 13),
        axis.text.x= element_text(size = 13),             # to hide text in x-axis
        axis.ticks.x=element_blank()) +           # to hide vach ke in x-axis
  labs(fill = "CPT_Class:");p

#write to files
png(filename= paste0(out_fig,'/Q1_ChangePoints/Exp4_allCPT_by_clusters.png'),
    width = 900, height = 350, type = "windows")
p
dev.off()

  
  
  


#---------------------------------------------------------------------------------------------#
####                 *Exp_Plot1* -  Strong CPT with Trend - Global map -   -----------
#---------------------------------------------------------------------------------------------#
df <- Rres[Rres$cpt_clas == "strong", ]
df <- df[!grepl("nonSig_",df$trend) & !is.na(df$trend), ]

df$trend_clas <- ifelse(grepl("_De", df$trend), "Decrease", "Increase")

# plot to world map
p <- baseworld2() +  
  geom_point(data = df,
             aes(x = longitude, 
                 y = latitude,
                 size = factor(trend_clas),
                 colour = factor(trend_clas) #, levels = c("strong", "pending", "weak"),
                 # labels = c("Strong", "Pending", "Weak")
             )
  ) +
  themeCPT_global(pts_size = c(4, 6),
                  color_lst = c("goldenrod2", "yellowgreen","palegreen1", "cyan4"),
                  title = "Trend in strong CPT:"); p


#save image
png(filename=paste0(out_fig,'/Q1_ChangePoints/Coverage.png'), 
    width = 3000, height = 1500, type = "windows")
print(p)
dev.off()


#---------------------------------------------------------------------------------------------#
####                 *Exp_Plot2* -  Strong CPT by decade - Global map -   -----------
#---------------------------------------------------------------------------------------------#
df$cpt_decade <- ifelse(df$cpt_ID <= 1975,
                        "1960s",
                        ifelse(df$cpt_ID <= 1990,
                               "1980s", "2000s"))

p <- baseworld2() +  
  geom_point(data = df,
             aes(x = longitude, 
                 y = latitude,
                 size = factor(cpt_decade),
                 colour = factor(cpt_decade) #, levels = c("strong", "pending", "weak"),
                 # labels = c("Strong", "Pending", "Weak")
             )
  ) +
  themeCPT_global(pts_size = c(4,5,6,7,8),
                  color_lst = c("white", "goldenrod2", "yellowgreen", "cyan4", "blue"),# "palegreen1",
                  title = "CPT by decades"); p


#save image
png(filename=paste0(out_fig,'/Fig1_ChangePoints/Exp2_strongCPT_by_decade.png'), width = 3000, height = 1500, type = "windows")
print(p)
dev.off()

