

#Author: Tinh Vu (tvu@hydrology.uni-kiel.de)


pkgs <- c('data.table',"sp","raster",'dplyr')
for (pkg in pkgs){
  if(!require(pkg,character.only = TRUE)){install.packages(pkg,dependencies = T); library(pkg,character.only = TRUE)}}

source("C:/Users/tinhv/Dropbox/PhD/Paper3_GlobalAnalysis/P3_Analysis/_RCoding/_supportFuncs/_callData.R")




#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++#
#                    0) PRECOOK - Extract whole dams per basin                ----
#      !!!!!!!!!!!!!!!    NO NEED TO DO AGAIN !!!!!!!!
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++#

#as the package spatialEco is no more supported/installed. Need to call the source of file
# source('D:/03. Work/09. R, Python Support/R-packages/spatialEco-master/spatialEco-master/R/point.in.poly.R') #use only used when use old method
# grand_shp <- raster::shapefile('D:/03. Work/00. PhD/00. Database/GlobalAnalysis/GRAND/GRanD_Version_1_3/GRanD_dams_v1_3.shp')     #this is original one without pre-cooked Rdata files
# 
# gsim_lst <- gsimFull$gsim.no
# 
# for(i in gsim_lst){
#   cat(i, "\n")
#   ### Get the basin shape (pre-cooked as Rdata file to speed up)
#   load(paste0(RDATADIR, "/",  gsub(".shp", "",i), ".RData"))
#   # plot(tmp_shp)
# 
#   #find all dams located inside basin
#   dam <- as.data.frame(
#     sp::over(tmp_shp, grand_shp, returnList = TRUE)
#   )
#   colnames(dam) <- gsub("X0.","", colnames(dam))
#   
#   #save datafiles 
#   out_file <- paste0(GlobalDATA, "/GRAND/PreCook_GRAND_1_3/", i, ".dam")
#   
#   write.table(dam, 
#               file = out_file, row.names = FALSE, sep = ",")
# }


#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++#
#                 1) Extract capacity of dam per each basin      ----
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++#
#================ NO NEED TO RUN AGAIN ===================================#
dam_files <- list.files(paste0(GlobalDATA, "/GRAND/PreCook_GRAND_1_3"),
                        pattern = ".dam", full.names = T)
f = dam_files[1]
CAP <- "CAP_MCM"
z <- list()
for (f in dam_files){ #example to test gsim_lst[47]
  gsim <- gsub(".dam", "",
               basename(f))
  cat("running", match(gsim, gsim_lst), gsim,"\n")
  dam_res <- read.table(f, header = T, sep = ",")
  dam_res <- dam_res[colnames(dam_res) %in% c('GRAND_ID','YEAR','MAIN_USE', CAP )]
  dam_res$YEAR <- ifelse(dam_res$YEAR < 0, NA, dam_res$YEAR)

  #if nodam
  if(nrow(dam_res) == 0){
    dam_res[1, ] <- 0 #changed on 23.04.2023 --> basin having no dam --> return to 0 instead of NA!
    dam_res$GRAND_ID <- NA
  }
  z[[f]] <- cbind(gsim.no = gsim,
               dam_res)
}
res <- rbindlist(z)
res <- res[!is.na(res$YEAR),] #!is.na(res$GRAND_ID) & 

write.table(res,
            paste0(out_dir,"/Res0_Precook/GRanD_list_full.csv"), row.names = FALSE, sep = ";")




#============  1.2 .Subset Dam on 01.05.2023 =============================
# D1: complete no dam in basin
# D2: only dam prior in basin (build before 1960)
# D3: dams built prior and between 1960-2010

grand <- read.table(paste0(out_dir,"/Res0_Precook/GRanD_list_full.csv"),header = TRUE,sep = ";") 
gsim_lst <- gsimFull$gsim.no; i=gsim_lst[1]

gsimFull$dam_set <- NA
i = 30
for (i in 1:nrow(gsimFull)){
  print(i)
  gsim <- gsimFull$gsim.no[i]
  
  #call precook dam in this basin and remove lines NA
  dt <- grand[grand$gsim.no == gsim, ]
  dt <- dt[!is.na(dt$GRAND_ID), ]
  
  #remove all dams build after 2010
  dt <- dt[dt$YEAR <= 2010,]; nrow(dt)
  
  nD2 <- nrow(dt[dt$YEAR <= 1960, ]); nD2
  nD3 <- nrow(dt[dt$YEAR > 1960 & dt$YEAR <= 2010,]); nD3
  
  
  if(nrow(dt) == 0){# having no dams --> D1
    gsimFull$dam_set[i] <- "D1"
    
  } else{ #having dams --> B, C
    gsimFull$dam_set[i] <- ifelse(nD3 == 0, "D2", "D3")
  }
}

#save file to precook
write.table(gsimFull[, c("gsim.no",  "dam_set")],
            paste0(out_dir, "/Res0_Precook/subsetDam.Rres"), row.names = F, sep = ",")

#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++#
#                    2) Dam_listA/B/C/D             ----
#subset dams from whole list based on 
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++#
grand <- read.table(paste0(out_dir,"/Res0_Precook/GRanD_list_full.csv"),header = TRUE,sep = ";") 
# write.table(grand,
#             paste0(out_dir, "/Res4_DataInfo_forPaper/Data3_ListDams_full.csv"),
#             row.names = F, sep = ",")


#select only basins having dams
damA <- grand[!is.na(grand$GRAND_ID),]
damA$MAIN_USE[is.na(damA$MAIN_USE)] <- "Other"

#join some info from gsim
damA <- left_join(damA, 
                     gsimFull[, c("gsim.no", "continent")],
                     "gsim.no")

# consider only dams build in period 1961-2010
damB <- damA[damA$YEAR >= 1960 & damA$YEAR <= 2010,]

# consider only dams build in period before 1960
damC <- damA[damA$YEAR < 1960,]

# consider only dams build until 2010
damD <- damA[damA$YEAR < 2010,]

#scan results 
# boxplot(damA$YEAR)
#remove unplausible dam?? SOME DAMS HAVING -99 built year
# nrow(as.data.frame(table(damB$gsim.no)))

#damA: 28877 dams build in whole full set, in 5216 basins
#damB: 15489 dams built from 1960-2010, in 3810 basins
#damC: 12351 dams built before 1960 in 3153 basins
#damD: 27738 dams built before 2010 in 5189 basins
write.table(damA,
            paste0(out_dir,"/Res0_Precook/Dam_listA.csv"), row.names = FALSE, sep = ";")
write.table(damB,
            paste0(out_dir,"/Res0_Precook/Dam_listB.csv"), row.names = FALSE, sep = ";")
write.table(damC,
            paste0(out_dir,"/Res0_Precook/Dam_listC.csv"), row.names = FALSE, sep = ";")
write.table(damD,
            paste0(out_dir,"/Res0_Precook/Dam_listD.csv"), row.names = FALSE, sep = ";")





#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++#
#                    3) List dams by purpose in continent               ----
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++#

wd <- c("Irrigation","Water supply")
nwd <- c("Fisheries","Flood control","Hydroelectricity","Recreation", "Other")


damList <- c("A", 'B', 'C', 'D')

zz <- list()
for(dl in damList){
  dams <- read.table(paste0(out_dir,"/Res0_Precook/Dam_list", dl,".csv"),header = TRUE,sep = ";") 
  
  z <- lapply(cont_lst,function(x){
    y <- dams[dams$continent == x,]
    
    bsin <- levels(as.factor(y$gsim.no))
    
    z1 <- lapply(bsin,function(x1){
      y1 <- y[y$gsim.no == x1,]
      p <- levels(as.factor(y1$MAIN_USE))
      
      p[p %in% wd] <- "wd"
      p[p %in% nwd] <- "nwd"
      
      plst <- levels(as.factor(p))
      clas <- ifelse(length(plst) >1,"multi",
                     ifelse(plst == "wd","withdraw","none-withdraw"))
      res <- data.frame(gsim.no=x1,
                        purpose=clas)
    })
    resz1 <- rbindlist(z1)
    
    pp <- as.data.frame(table(resz1$purpose))
    
    df <- data.frame(continent = x,
                     multi = pp$Freq[pp$Var1 == "multi"],
                     none_withdraw = pp$Freq[pp$Var1 == "none-withdraw"],
                     withdraw = pp$Freq[pp$Var1 == "withdraw"],
                     dams_num = sum(pp$Freq))
    
  })
  resz <- as.data.frame(do.call(rbind,z))
  resz$set_dam <- dl
  
  zz[[dl]] <- resz
}

res_all <- rbindlist(zz)
write.table(res_all,
            paste0(out_dir,"/Res0_Precook/Purpose_of_dams.csv"), row.names = FALSE, sep = ";")






#xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx BACK UP xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx#

#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++#
#                 2) PRECOOK - EXTRACT number OF DAM per basin      ----1
# extract directly from shape file
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++#


fs <- list.files(paste0(GlobalDATA, "/GRAND/PreCook_GRAND_1_3"), 
                 pattern = ".dam", full.names = T)


z <- list()
for (i in gsim_lst){
  ### Print the current ID to follow the process
  cat(paste0("running basin ",match(i,gsim_lst)," (",i,")"),"\n")
  
  ### Get the basin shape (pre-cooked as Rdata file to speed up)
  load(paste0(RDATADIR, "/",  gsub(".shp", "",i), ".RData"))
  # plot(tmp_shp)
  
  #find all dams located inside basin
  dam <- as.data.frame(
    sp::over(tmp_shp, grand_shp, returnList = TRUE)
  )
  colnames(dam) <- gsub("X0.","", colnames(dam))
  
  #---------------- OLD METHOD, DOESNT WORK WITH SOME BASINS -------------------------#
  #clip the point which falls into the polygon
  # c <- as.data.frame(point.in.poly(grand_shp,tmp_shp)) #          !!!!  SOMEHOW THIS FUNCTION DOENT WORK WITH SOME BASINS --> COPY RESULTS !!!!
  # 
  # #find only the one stay in the basins
  # dam <- c[is.na(c$FILENAME)==FALSE,]
  # if(nrow(dam) ==0){
  #   dam[1,] <- NA
  # }
  #---------------- OLD METHOD, DOESNT WORK WITH SOME BASINS -------------------------#
  
  
  #select few colums
  res <- cbind(gsim.no = rep(i,nrow(dam)),
               dam[colnames(dam) %in% c('GRAND_ID','YEAR','MAIN_USE',"CAP_MCM")])
  
  z[[i]] <- res
}# close foreach

all_res <- rbindlist(z) 
write.table(all_res,
            paste0(out_dir,"/Res0_Precook/Dam_listA.csv"), row.names = FALSE, sep = ",")
