



pkgs <- c('data.table',"sp","raster",'dplyr')
for (pkg in pkgs){
  if(!require(pkg,character.only = TRUE)){install.packages(pkg,dependencies = T); library(pkg,character.only = TRUE)}}

source("C:/Users/tinhv/Dropbox/PhD/Paper3_GlobalAnalysis/P3_Analysis/_RCoding/_supportFuncs/_callData.R")


#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++#
#                    0) PRECOOK - Extract KG Zone by basin               ----
#    
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++#
# ca 3min
kg_shp <- raster::shapefile("D:/03. Work/00. PhD/00. Database/GlobalAnalysis/Koppen_Geiger ClimateZones.shp/Shapefiles/world_climates_completed_koppen_geiger.shp")

#just forcus only to significant dam changing
f_cpt <- paste0(out_dir,"/Res1_Changepoint/Final_CPT_setB_MEAN.Rres"); print(f_cpt)
res_cpt <- read.table(f_cpt, header = TRUE, sep = ",")
gsim_lst <- res_cpt$gsim.no[!is.na(res_cpt$cpt_ID)]

i = 1329#"BR_0000243"
z <- list()
bg <- Sys.time()
for(i in 1108:5000){
# for(i in 1:length(gsim_lst)){
  cat(i, "\n")
  gsim <- gsim_lst[i]
  
  ### Get the basin shape (pre-cooked as Rdata file to speed up)
  load(paste0(RDATADIR, "/",  gsub(".shp", "",gsim), ".RData"))#; plot(tmp_shp)
  
  # 8.1 sec
  kg <- as.data.frame(sp::over(tmp_shp, kg_shp, returnList = TRUE))
  if(nrow(kg) == 0) kg <- data.frame(dn = NA,
                                     climates_f = NA)
  kg$gsim.no <- gsim
  z[[i]] <- kg
}

res <- as.data.frame(do.call(rbind, z))
res <- res[, c("gsim.no", "climates_f", "dn")]

write.table(res,
            file = paste0(out_dir,"/Res0_Precook/KGzone_1108.Rres"),
            row.names = FALSE, sep = ",")
print(Sys.time()-bg)




# #++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++#
# #                 1) Extract main KG zone per each basin ()       ----
# #++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++#

res_kg <- read.table(paste0(out_dir,"/Res0_Precook/KGzone_details.Rres"), header = T, sep = ",")
gsim_lst <- gsimFull$gsim.no

gsimFull$KG_zone <- NA #reclassify zone 9-10 zones
gsimFull$KG_mainzone <- NA #main zones A-E
gsimFull$KG_actzone <- NA #for actual zones 

for(i in 1:nrow(gsimFull)){
  # print(i)
  gsim <- gsimFull$gsim.no[i]
  kg <- res_kg[res_kg$gsim.no == gsim, ]

  if(nrow(kg) != 0){
    x <- as.data.frame(table(kg$climates_f)); x$Var1 <- as.character(x$Var1)
    if(nrow(x) == 0){
      sz = NA
      mz = NA
    } else {

      #-------------- reclassify zones -------------------------
      x$sub_cf <- substr(x$Var1, 1,2)
      x$sub_cf <- ifelse(grepl("A|B|E", x$sub_cf), substr(x$sub_cf, 1, 1),
                         x$sub_cf)
      cf_lst <- unique(x$sub_cf)

      l <- lapply(cf_lst, function(j){
        y = x[x$sub_cf == j,]
        y <- sum(y$Freq)
        y <- data.frame(cz = j,
                        freq = y)
      })
      dt <- as.data.frame(rbindlist(l))
      dt$perc <- dt$freq*100/sum(dt$freq)

      sz <- dt$cz[dt$perc == max(dt$perc)]

      #----------- main zones ---------------------------------------
      x$main_cf <- substr(x$Var1, 1,1); mf_lst <- unique(x$main_cf)

      l <- lapply(mf_lst, function(j){
        y = x[x$main_cf == j,]
        y <- sum(y$Freq)
        y <- data.frame(cz = j,
                        freq = y)
      })
      dt <- as.data.frame(rbindlist(l))
      dt$perc <- dt$freq*100/sum(dt$freq)

      mz <- dt$cz[dt$perc == max(dt$perc)]
      
      #----------- sub zones ---------------------------------------
      cf_lst <- unique(x$Var1)
      l <- lapply(cf_lst, function(j){
        y = x[x$Var1 == j,]
        y <- sum(y$Freq)
        y <- data.frame(cz = j,
                        freq = y)
      })
      dt <- as.data.frame(rbindlist(l))
      dt$perc <- dt$freq*100/sum(dt$freq)
      az <- dt$cz[dt$perc == max(dt$perc)]
      
      #------------ control the zones ------------------------------------#
      if(length(mz) > 1) mz <- mz[1]
      if(length(sz) > 1){
        sz <- sz[grepl(mz, sz)][1]
      }
      if(length(az) > 1) az <- az[grep(sz, az)][1]
      
      
      #------------ correct CSb to Csb ------------------------------------#
      # tren original map khong co CSb, chi co Csb
      if(sz == "CS") print(paste0(gsim, "---", nrow(kg)))
      if(grepl("CS", sz)) sz <- "Cs"
      if(grepl("CS", az)) az <- gsub("CS", "Cs", az)
      
      
      #-------------------------------------------------------------------#
    }

    gsimFull$KG_zone[i] <- sz #reclassify zone 9-10 zones
    gsimFull$KG_mainzone[i] <- mz #main zones A-E
    gsimFull$KG_actzone[i] <- az #for actual zones 

  }
}

df <- gsimFull[, c("gsim.no", "KG_zone", "KG_mainzone", "KG_actzone")]
# x <- df[!is.na(df$KG_zone),];table(x$KG_zone)
write.table(df,
            file = paste0(out_dir,"/Res0_Precook/KGzone_final.Rres"),
            row.names = FALSE, sep = ",")





# #++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++#
# #                 2) Extract main KG zone per each basin - old      ----
# #++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++#

res_kg <- read.table(paste0(out_dir,"/Res0_Precook/KGzone_details.Rres"), header = T, sep = ",")
gsim_lst <- gsimFull$gsim.no

gsimFull$KG_zone <- NA
gsimFull$KG_subzone <- NA
gsimFull$KG_mainzone <- NA

for(i in 1:nrow(gsimFull)){
  print(i)
  gsim <- gsimFull$gsim.no[i]
  
  kg <- res_kg[res_kg$gsim.no == gsim, ]
  
  if(nrow(kg) != 0){
    x <- as.data.frame(table(kg$climates_f)); x$Var1 <- as.character(x$Var1)
    x$sub_cf <- substr(x$Var1, 1,2)
    x$main_cf <- substr(x$Var1, 1,1)
    
    if(nrow(x) == 0){
      z = NA
      sz = NA
      mz = NA
    } else {
      z <- as.character(x$Var1[x$Freq == max(x$Freq)]); z
      s <- as.data.frame(table(x$sub_cf)); sz <- as.character(s$Var1[s$Freq == max(s$Freq)]); sz
      m <- as.data.frame(table(x$main_cf)); mz <- as.character(m$Var1[m$Freq == max(m$Freq)]); mz
      
      if(length(sz) > 1) {
        if(grepl(mz, paste(sz, collapse = "|")) & grepl(mz, paste(z, collapse = "|"))){
          sz1 <- as.character(na.omit(
            unlist(lapply(sz, function(j){
              if(!grepl(j, paste(z, collapse = "|"))) {
                j = NA
              } else {j}
              j
            })
            )))
          if(length(sz1) == 0){
            sz <- sz[1]
          } else { 
            sz <- sz1}
        }else {
          sz <- sz[1]
        }
      }
      if(length(z) > 1) z <- z[grep(sz, z)][1]
    }
    
    
    gsimFull$KG_zone[i] <- z
    gsimFull$KG_subzone[i] <- sz
    gsimFull$KG_mainzone[i] <- mz
    
  }
}
write.table(gsimFull[, c("gsim.no", "KG_zone", "KG_subzone", "KG_mainzone")],
            file = paste0(out_dir,"/Res0_Precook/KGzone_final.Rres"),
            row.names = FALSE, sep = ",")
