
f <- paste0(Qpath, "/AF_0000015.year")
file.exists(f)

# Count the # Count the # Count the number of NA in files  - done 
#GA0_Precook_GSIMStudy
na.check <- function(f) {
  print(basename(f))
  df <- read.table(f,header = TRUE,sep = ",")
  
  gsim.no <- strsplit(basename(f), "\\.")[[1]][1]

  #select column in use and rename them as format
  df <- df[,c("date","MEAN","n.missing")]
  colnames(df)[2] <- "discharge"         #select Calculated column as discharge 
  
  
  #assign NA for all discharge<0, not simply do like this   df[df=='-999'] <- NA --> still occurs values -99!!!!
  for ( i in 1:nrow(df)) {
    if (df$n.missing[i] > 30) { 
      df$discharge[i]<- NA
    }
  }
  
  #summary of missing days
  a <- df[is.na(df$discharge)==TRUE,]
  NA_days <- sum(a$n.missing)
  
  #run length endcoding to find the consecutive nonNA or NA 
  rle.isna <- rle(is.na(df$discharge))
  
  #turn the rle class to dataframe to process next step
  rle_dfr <- data.frame(unclass(rle.isna))
  
  
  #find the consecutive NA (with TRUE only)
  rle_dfr_na <- list(rle_dfr$lengths[rle_dfr$values == TRUE])
  num_gap <- length(rle_dfr_na[[1]])
  
  if (num_gap == 0) { 
    max_gap <- 0 
  } else {
    max_gap <- max(rle_dfr_na[[1]])
  }
  
  #newly added on 05.02.2018 --> control the gap at begining and ending of series-----------------#
  z <- c(1, nrow(rle_dfr))  #select gap at begining/ending only
  for (i in z) {
    if (rle_dfr$values[i] == 'TRUE') {
      rle_dfr$values[i] <- 'remove'
    } else { }
  }
  
  rle_dfr_na <- list(rle_dfr$lengths[rle_dfr$values == TRUE])
  num_gap_mdle <- length(rle_dfr_na[[1]])
  
  if (num_gap_mdle == 0) { 
    max_gap_mdle <- 0 
  } else {
    max_gap_mdle <- max(rle_dfr_na[[1]])
  }
  
  #list the gap in begining or ending that removed
  if (rle_dfr$values[1] == 'remove') {
    gap_begin <- rle_dfr$lengths[1]
  } else {
    gap_begin <- 0
  }
  
  
  if (rle_dfr$values[nrow(rle_dfr)] == 'remove') {
    gap_end <- rle_dfr$lengths[nrow(rle_dfr)]
  } else {
    gap_end <- 0
  }
  
  #create data frame to write result of NA pattern into file
  na_pattern <- data.frame(gsim.no = gsim.no,  # to take only number from full file name 123456.day
                           length = nrow(df),
                           NA_days = NA_days,
                           num_gap,
                           max_gap,
                           gap_begin,
                           gap_end,
                           num_gap_mdle,
                           max_gap_mdle)   
}  #close the function loop


#---------------------------------------------------------------"
plot.test <- function(data,
                     option='boxplot'){
  rownames(data) <- NULL
  dat <- reshape2::melt(as.data.frame(data))
  p <- ggplot(dat,aes(variable,value))
  
  if(grepl('bar',option)) p <- p+geom_bar(stat = "identity")
  if(grepl('violin',option)) p <- p+geom_violin()
  if(grepl('box',option)) p <- p+geom_boxplot()
  return(p)
  }

min_max_norm <- function(x) {
  (x - min(x)) / (max(x) - min(x))
}

z.transform <- function(x){
  zVar <- (x - mean(x)) / sd(x)
  zVar
}

sum_by_row2 <- function(data,
                        columns){
  data.new <- data[,columns]
  data.new <- cbind(data.new, sum = rowSums(data.new))
  data$sum <- data.new$sum
  
  return(data)
}


aggregateNEW <- function(data,
                         ref.column = 'category'){
  data <- as.data.frame(data)
  col <- grep(ref.column,names(data))
  names(data)[col] <- 'category'
  factors <- levels(as.factor(data$category))
  
  z <- lapply(factors,function(f){
    dat.f <- data[data$category == f,]

    z1 <- lapply(1:ncol(data),function(j){
      name <-  names(dat.f)[j]
      
      if(j == col){
        res = data.frame(val = unique(dat.f[,j]))
      }else {
        val <- na.omit(dat.f[,j])
        res <- data.frame(val = sum(val))
      }
      names(res) <- name
      res
    })
    res <- do.call(cbind,z1)
    res
  })
  res <- do.call(rbind,z)
  return(as.data.frame(res))
}




removedoubleColnames <- function(data,
                                 removeCols){
  names <- names(data)
  all.cols <- seq(ncol(data)) 
  
  double.cols <- grep(removeCols,names)
  remain.col <-  all.cols[-which(all.cols %in% double.cols)]

  select.cols <- c(min(double.cols),
                   remain.col)
  data <- data[,select.cols]
  return(data)
}




firstup <- function(x) {
  substr(x, 1, 1) <- toupper(substr(x, 1, 1))
  x
}

toCharacter <- function(data){
  for(j in seq(ncol(data))){
    if(is.factor(data[,j])) data[,j] <- as.character(data[,j])
    data[,j] <- data[,j]
  }
  data
}
toNumeric<- function(data){
  for(j in seq(ncol(data))){
    if(is.factor(data[,j])|is.character(data[,j])) data[,j] <- as.numeric(data[,j])
    data[,j] <- data[,j]
  }
  data
}


#Get the appreviation of words (Tinh Vu = TV)
cont_abbr <- function(x){
  toupper(lapply(x, function(x) abbreviate(x,
                                           minlength = 2,method = 'left.kept',use.classes = FALSE)))
}


checkClass <- function(data){
  sapply(data,class)
}


cbindNEW <- function(list){
  data <- as.data.frame(do.call(cbind,list))
  return(data)
}


rbindNEW <- function(list){
  data <- as.data.frame(do.call(rbind,list))
  return(data)
}



firstLetter <- function(x){
  substr(x,1,1)
}


getymin <- function(x){
  round(min(na.omit(x)),digits = -1)
}

getymax<- function(x){
  round(max(na.omit(x)),digits = -1)+10
}




#=======================================================================================================#

#find gaps from a series. A list of number of gaps will be return --> find max, num gap
findgap <- function(x){
  #run length endcoding to find the consecutive nonNA or NA 
  rle.isna <- rle(is.na(x))
  
  #turn the rle class to dataframe to process next step
  rle_dfr <- data.frame(unclass(rle.isna))
  
  #find the consecutive NA (with TRUE only)
  rle_dfr_na <- list(rle_dfr$lengths[rle_dfr$values == TRUE])
  return(rle_dfr_na[[1]])
}


#Return continents from long/lat
coords2continent = function(points) {  
  countriesSP <- getMap(resolution='low')
  pointsSP = SpatialPoints(points, proj4string=CRS(proj4string(countriesSP)))  
  indices = over(pointsSP, countriesSP)
  indices$REGION   # returns the continent (7 continent model)
}




#Check whether the value make sense
perCheck <- function(df,VAR,stats){
  c <- df[colnames(df) %in% c('gsim.no',VAR)]; colnames(c)[2] <- 'VAR'
  c <- c[!is.na(c$VAR),]
  
  s <- ifelse(stats=='min',
              min(c$VAR),
              ifelse(stats=='max',
                     max(c$VAR),
                     ifelse(stats=='quant',
                            quantile(c$VAR,probs = c(.75)),
                            stop("No stats is provided!"))))
  gsim <- ifelse(stats %in% c("min","max"),
                 as.character(c$gsim.no[c$VAR==s]),
                 length(c$gsim.no[c$VAR>= s]))
  
  return(data.frame(gsim,
                    stats=s))
}


getPrePost <- function(proj,VAR,gsim){
  df <- data.table::read.table(
    paste0(proj,'/P3_Results/outTiffsRres_clean/',VAR,'.Rres'),header = TRUE,sep = ",")
  df[df$gsim.no==gsim,]
}



#-------------------------------- point.in.poly ------------------------------------------
#' @title Point and Polygon Intersect
#' @description Intersects point and polygon feature classes and adds polygon attributes to points
#'
#' @param x         sp SpatialPointsDataFrame or SpatialPoints or sf point object
#' @param y         sp SpatialPolygonsDataFrame or sf polygon object
#' @param sp        (TRUE/FALSE) Return an sp class object, else returns sf class object
#' @param duplicate (TRUE/FALSE) Return duplicated features with more than one polygon intersection
#' @param ...       Additional arguments passed to sf::st_join  
#'
#' @return A SpatialPointsDataFrame or sf 
#'
#' @note 
#' If duplicate argument is TRUE and more than one polygon intersection occurs, points will be duplicated (new row added) and all attributes joined.  
#' However, if duplicate is FALSE, with duplicate intersections, a new column for each unique intersecting polygon will 
#' be returned and the points will not be duplicated. For example, if a point intersect three polygons, three new columns will be added
#' representing the polygons ID.    
#'
#' @author Jeffrey S. Evans  <jeffrey_evans@@tnc.org>
#'
#' @examples
#'  #### Simple one-to-one feature overlay. 
#'  require(sp)
#'    data(meuse)
#'    coordinates(meuse) = ~x+y
#'    meuse@data$test.na <- NA
#'  
#'    sr1=Polygons(list(Polygon(cbind(c(180114, 180553, 181127, 181477, 181294,  
#'      181007, 180409, 180162, 180114), c(332349, 332057, 332342, 333250, 333558,  
#'      333676, 332618, 332413, 332349)))),'10')
#'    sr2=Polygons(list(Polygon(cbind(c(180042, 180545, 180553, 180314, 179955, 179142,  
#'      179437, 179524, 179979, 180042), c(332373, 332026, 331426, 330889, 330683, 
#'      331133, 331623, 332152, 332357, 332373)))),'20')
#'    sr3=Polygons(list(Polygon(cbind(c(179110, 179907, 180433, 180712, 180752, 180329, 
#'      179875, 179668, 179572, 179269, 178879, 178600, 178544, 179046, 179110),
#'      c(331086, 330620, 330494, 330265, 330075, 330233, 330336, 330004, 
#'      329783, 329665, 329720, 329933, 330478, 331062, 331086)))),'30')
#'    sr4=Polygons(list(Polygon(cbind(c(180304, 180403,179632,179420,180304),
#'      c(332791, 333204, 333635, 333058, 332791)))),'40')
#'    sr=SpatialPolygons(list(sr1,sr2,sr3,sr4))
#'    polys=SpatialPolygonsDataFrame(sr, data.frame(row.names=c('10','20','30','40'), 
#'                                   PIDS=1:4, y=runif(4)))
#'    polys@data$pid <- polys@data$PIDS + 100 
#'  
#'  plot(polys)
#'    plot(meuse, pch=19, add=TRUE)  
#'    
#'  # Point in polygon overlay  
#'  pts.poly <-  point.in.poly(meuse, polys)
#'    head(pts.poly@data)
#'  
#'  # Count points in each polygon
#'  tapply(pts.poly$cadmium, pts.poly$pid, FUN=length)    
#'    
#'  #### Complex many-to-one feature overlay. 
#'  require(sf)
#'  p <- sf::st_polygon(list(rbind(c(0,0), c(1,0), c(1,1), c(0,1), c(0,0))))
#'  polys <- sf::st_sf(sf::st_sfc(p, p + c(.8, .2), p + c(.2, .8)))
#'  pts <- sf::st_sf(sf::st_sample(polys, size=100))
#'  
#'  # Duplicates points for each new polygon, no attributes so returns IDs for features    
#'  pts.poly.dup <-  point.in.poly(pts, polys)
#'    head(pts.poly.dup@data)
#'    
#' \dontrun{
#'  # **** Should throw error due to lack of attributes ****  
#'    pts.poly <- point.in.poly(pts, polys, duplicate = FALSE) 
#' }
#'  
#'  # Coerce to sp class objects
#'  x <- as(pts, "Spatial")
#'    x <- SpatialPointsDataFrame(x, data.frame(IDS=1:nrow(x), pty=runif(nrow(x))))
#'  y <- as(polys, "Spatial")
#'    y <- SpatialPolygonsDataFrame(y, data.frame(IDS=1:nrow(y), py=runif(nrow(y))))
#'  
#'  # Returns point attributes with column for each unique polygon   
#'  pts.poly <- point.in.poly(x, y, duplicate = FALSE)
#'    head(pts.poly@data)  
#'    
#'  # Duplicates points for each new polygon, joins all attributes  
#'  pts.poly.dup <-  point.in.poly(x, y)
#'    head(pts.poly.dup@data)  
#'  
#'  # Count points in each polygon
#'  tapply(pts.poly.dup$IDS.x, pts.poly.dup$IDS.y, FUN=length)      
#'
#' @import sf
#' @export
point.in.poly <- function(x, y, sp = TRUE, duplicate = TRUE, ...) {
  if(!any(class(x)[1] == c("SpatialPoints", "SpatialPointsDataFrame", "sf"))) {
    stop("x is not a suitable point feature object class") }
  if(!any(class(y)[1] == c("SpatialPolygons", "SpatialPolygonsDataFrame", "sf"))) {
    stop("y is not a suitable polygon feature object class") }
  if(any(class(x) == "sfc")) { x <- sf::st_sf(x) }  
  if(duplicate == FALSE) {
    if(!any(class(x)[1] == c("SpatialPoints", "SpatialPointsDataFrame"))) {
      x <- as(x, "Spatial")
      if(dim(x@data)[2] == 0) stop("There are no attributes associated with points")
    }	
    if(!any(class(y)[1] == c("SpatialPolygons", "SpatialPolygonsDataFrame"))) {
      y <- as(y, "Spatial")
      if(dim(y@data)[2] == 0) stop("There are no attributes associated with polygons")
    }
    o <- sp::over(x, y, returnList = TRUE)
    m <- max(unlist(lapply(o, nrow)))
    ids <- row.names(y)
    xy <- data.frame(t(sapply(1:length(o), 
                              function(i) c(ids[i], c(o[[i]][,1], rep(NA, m))[1:m])
    )))
    colnames(xy) <- c("p",paste0("pid", 1:m))
    x@data <- data.frame(x@data, xy)
    if( sp == FALSE ) sf::st_as_sf(x) 
    return( x )
  } else {
    if(any( class(x) == c("SpatialPoints", "SpatialPointsDataFrame"))) {
      x <- sf::st_as_sf(x)
    }
    if(any(class(y) == "sfc")) { x <- sf::st_sf(y) }
    if(any( class(y) == c("SpatialPolygons", "SpatialPolygonsDataFrame"))) {
      y <- sf::st_as_sf(y)	
    } 
    if(dim(x)[2] == 1) x$pt.ids <- 1:nrow(x)	
    if(dim(y)[2] == 1) y$poly.ids <- 1:nrow(y)	  
    o <- sf::st_join(x, y, ...)
    if( sp ) o <- as(o, "Spatial")
    # if( sp ) o <- sf::as_Spatial(o)
    return( o ) 
  } 
}