

#https://stackoverflow.com/questions/19627344/how-to-create-a-raster-from-a-data-frame-in-r


library(sp)

f=99.9
n.sample = 1000

RandVar <- function(f,
                    n.sample){
  #+++++++++++++++++++++++++++++++++++ CACH 1 - TIN CAY HON, DUNG CHO PAPER ++++++++++++++++++++++++++++++++++++++ ----
  # step 1: tao ra luoi 0.5 do
  x=seq(-180,180,0.5) 
  y=seq(-90,90,0.25)
  
  z<-list()
  for(i in 1:length(x)){
    # print(i)
    z[[i]] <- data.frame(rep(x[i],length(y)),
                         y)
  }
  res <- do.call(rbind,z); colnames(res)[1] <- 'x'
  vals <- sample(1:n.sample,nrow(res),replace = TRUE) #; plot(vals)
  
  df <- cbind(res,vals)
  
  library(raster)
  r <- rasterFromXYZ(df)  #Convert first two columns as lon-lat and third as value                
  # plot(r)
  
  return(r)
  
  #+++++++++++++++++++++++++++++++++++ CACH 2 - REGULAR --> KHONG THUC SU PHU HOP ++++++++++++++++++++++++++++++++++++++
  # arrange coordinates of future spatial polygon into a  matrix 
  # xmin,xmax,xmax,xmin,ymin,ymin,ymax,ymax, rows, cols
  # xym <- matrix(c(-180, 180, 180, -180, -90, -90, 90, 90), nrow = 4, ncol = 2)
  # 
  # # create Polygon
  # p <- Polygon(xym)
  # 
  # # wrap Polygon into Polygons object
  # ps <- Polygons(list(p), 1)
  # 
  # # wrap Polygons object into SpatialPolygons object
  # sps <- SpatialPolygons(list(ps))
  # 
  # # set CRS of polygon 
  # proj4string(sps) <- CRS("+proj=longlat +datum=WGS84")
  # 
  # data <- data.frame(99.)
  # spdf <- SpatialPolygonsDataFrame(sps, data)
  # 
  # library(raster)
  # ptsreg <- spsample(spdf, n.sample, type = 'regular') #return results in grids
  # r <- rasterFromXYZ(coordinates(ptsreg))
  # r[] <- 1:ncell(r) # add some values
  # 
  #   # check the results are correct
  # plot(r,xlim=c(-180,180))
  # points(ptsreg, pch = ".", col = "black",cex=2)
}


#------------ CREATE FOR 1960-2020 ----------
for (y in 1960:2010){
  cat(y,"\n")
  r1 <- RandVar(f=99,
               n.sample = 1000)
  writeRaster(r1, filename=paste0("D:/03. Work/00. PhD/00. Database/GlobalAnalysis/RandomVar/",
                                y, "_prior.tif"), format="GTiff")
  
  r2 <- RandVar(f=99,
               n.sample = 1000)
  writeRaster(r2, filename=paste0("D:/03. Work/00. PhD/00. Database/GlobalAnalysis/RandomVar/",
                                y, "_post.tif"), format="GTiff")
}


