



lib_lst <- c('data.table',"dplyr") 

for (lib in lib_lst){
  if(!require(lib,character.only = TRUE)){install.packages(lib,dependencies = T); library(lib,character.only = TRUE)}}




#================================= CALCULATING WATER VOLUME =============================================#
# Calculate water volume (km3/km2)
# added on 2.12.2019, new calculated on 10.04.2020
calcVolume <- function(area,
                       flow,
                       dataSet,
                       out_tiff
){
  dis <- fread(paste0(out_tiff,'/Discharge.Rres'))
  
  colnames(dis)[3:4] <- c('dis_pre','dis_post')
  
  dfj <-left_join(dis,area,by='gsim.no')
  
  
  #calculate the volumn of water (in 10-3 km3/km2) --> if not, the value is super small --> make no sense
  dfj$pre_avg <- ifelse(is.na(dfj$area)==TRUE,
                        0,
                        dfj$dis_pre*365*24*3600*10^-6/dfj$area) #so that unit could be 10-3
  dfj$post_avg <- ifelse(is.na(dfj$area)==TRUE,
                         0,
                         dfj$dis_post*365*24*3600*10^-6/dfj$area) 
  
  return(dfj)
}#end of function



#================================= CALCULATING RATIO OF DAM =============================================#
# #old function which used the datafile coombine w, nw ---> no more needed
# calcRatio <- function(flow,
#                       dataSet,
#                       damSet,
#                       damType,
#                       out_tiff){
#   
#   grand <- fread(paste0(out_tiff,'/Dam_', damSet,'.Rres'))
# 
#   
#   df <- right_join(dis,grand[,-2],'gsim.no')
#   df <- df[,  c('gsim.no','cpt_ID','pre_avg','post_avg',
#                 'cap_w_pre','cap_w_post',
#                 'cap_nw_pre','cap_nw_post')]
#   
#   ifelse(damType=='Dam_Withdraw',
#          dfr <- df[,c('gsim.no','pre_avg','post_avg',
#                       'cap_w_pre','cap_w_post')],
#          dfr <- df[,c('gsim.no','pre_avg','post_avg',
#                       'cap_nw_pre','cap_nw_post')])
#   
#   colnames(dfr)[4:5] <- c('cap_pre','cap_post')
#   
#   #calculate the damType
#   # cap (10^6 m3) - theo huong dan cua GranD, page 8, Technical Doku
#   # W = Q.T (m3)
#   dfr$R_pre <- ifelse(is.na(dfr$pre_avg)==TRUE | dfr$pre_avg ==0,
#                       NA,
#                       (dfr$cap_pre*1000000/(dfr$pre_avg*365*24*60*60))*100) # x100 --> to name it as percentage
#   dfr$R_post <- ifelse(is.na(dfr$post_avg)==TRUE | dfr$post_avg ==0,
#                        NA,
#                        (dfr$cap_post*1000000/(dfr$post_avg*365*24*60*60))*100)
#   
#   dfr <- dfr[,c('gsim.no','cap_pre','cap_post','R_pre','R_post')]
#   
#   return(dfr)
#   
# }#close function


# 
# 
# #old function which used the datafile coombine w, nw
# calcRatio <- function(flow,
#                       dataSet,
#                       damSet,
#                       damType,
#                       out_tiff){
#   
#   grand <- fread(paste0(out_tiff,'/GRanD_dam', damSet,'.Rres'))
#   dis <- fread(paste0(out_tiff,'/Discharge.Rres'))
#   
#   df <- right_join(dis,grand[,-2],'gsim.no')
#   df <- df[,  c('gsim.no','cpt_ID','pre_avg','post_avg',
#                 'cap_w_pre','cap_w_post',
#                 'cap_nw_pre','cap_nw_post')]
# 
#   ifelse(damType=='Dam_Withdraw',
#          dfr <- df[,c('gsim.no','pre_avg','post_avg',
#                       'cap_w_pre','cap_w_post')],
#          dfr <- df[,c('gsim.no','pre_avg','post_avg',
#                       'cap_nw_pre','cap_nw_post')])
#   
#   colnames(dfr)[4:5] <- c('cap_pre','cap_post')
#   
#   #calculate the damType
#   # cap (10^6 m3) - theo huong dan cua GranD, page 8, Technical Doku
#   # W = Q.T (m3)
#   dfr$R_pre <- ifelse(is.na(dfr$pre_avg)==TRUE | dfr$pre_avg ==0,
#                       NA,
#                       (dfr$cap_pre*1000000/(dfr$pre_avg*365*24*60*60))*100) # x100 --> to name it as percentage
#   dfr$R_post <- ifelse(is.na(dfr$post_avg)==TRUE | dfr$post_avg ==0,
#                        NA,
#                        (dfr$cap_post*1000000/(dfr$post_avg*365*24*60*60))*100)
#   
#   dfr <- dfr[,c('gsim.no','cap_pre','cap_post','R_pre','R_post')]
#   
#   return(dfr)
#     
# }#close function





